#pragma once

#include "BiffRecord.h"
#include <Logic/Biff_structures/LongRGB.h>

namespace XLS
{


// Logical representation of AreaFormat record in BIFF8
class AreaFormat: public BiffRecord
{
	BIFF_RECORD_DEFINE_TYPE_INFO(AreaFormat)
	BASE_OBJECT_DEFINE_CLASS_NAME(AreaFormat)
public:
	AreaFormat();
	~AreaFormat();

	BaseObjectPtr clone();

	void writeFields(CFRecord& record);
	void readFields(CFRecord& record);
		
	static const ElementType	type = typeAreaFormat;

	int serialize(std::wostream & _stream);

	LongRGB rgbFore;
	LongRGB rgbBack;
	
	_UINT16 fls;
	
	bool fAuto;
	bool fInvertNeg;
	
	IcvChart icvFore;
	IcvChart icvBack;
};

} // namespace XLS

