
#include "ItemMoniker.h"
#include <Binary/CFRecord.h>

namespace OSHARED
{


ItemMoniker::ItemMoniker()
{
}


ItemMoniker::ItemMoniker(XLS::CFRecord& record)
{
	load(record);
}


XLS::BiffStructurePtr ItemMoniker::clone()
{
	return XLS::BiffStructurePtr(new ItemMoniker(*this));
}



void ItemMoniker::store(XLS::CFRecord& record)
{
#pragma message("####################### ItemMoniker record has no BiffStructure::store() implemented")
	Log::error(" Error!!! ItemMoniker record has no BiffStructure::store() implemented.");
	//record << something;
}


void ItemMoniker::load(XLS::CFRecord& record)
{
	_UINT32 delimiterLength;
	record >> delimiterLength >> delimiterAnsi;
	
	int sizeof_delimiterUnicode = delimiterLength - (delimiterAnsi.length() + 1);

    if(sizeof_delimiterUnicode > 0)
	{		
#if defined(_WIN32) || defined(_WIN64)
        delimiterUnicode = std::wstring(record.getCurData<wchar_t>(), sizeof_delimiterUnicode / 2);
#else
        delimiterUnicode = XLS::convertUtf16ToWString(record.getCurData<UTF16>(), sizeof_delimiterUnicode / 2);
#endif
        record.skipNunBytes(sizeof_delimiterUnicode);
	}

	_UINT32 itemLength;
	record >> itemLength >> itemAnsi;
	
	int sizeof_itemUnicode = itemLength - (itemAnsi.length() + 1);

    if(sizeof_itemUnicode > 0)
	{		
#if defined(_WIN32) || defined(_WIN64)
        itemUnicode = std::wstring(record.getCurData<wchar_t>(), sizeof_itemUnicode / 2);
#else
        itemUnicode = XLS::convertUtf16ToWString(record.getCurData<UTF16>(), sizeof_itemUnicode / 2);
#endif
        record.skipNunBytes(sizeof_itemUnicode);
	}

}


} // namespace OSHARED

