#-------------------------------------------------
#
# Project created by QtCreator 2014-12-16T18:28:23
#
#-------------------------------------------------

QT       -= core gui

TARGET = XlsFormatLib
TEMPLATE = lib
CONFIG += staticlib

CONFIG += c++11

win32 {
    QMAKE_CXXFLAGS_RELEASE -= -Zc:strictStrings
    QMAKE_CXXFLAGS += /bigobj
} else {
    QMAKE_CXXFLAGS += -std=c++11 -Wall -Wno-ignored-qualifiers
}
############### destination path ###############
DESTINATION_SDK_PATH = $$PWD/../../../build/lib

# WINDOWS
win32:contains(QMAKE_TARGET.arch, x86_64):{
CONFIG(debug, debug|release) {
    DESTDIR = $$DESTINATION_SDK_PATH/win_64/DEBUG
} else {
    DESTDIR = $$DESTINATION_SDK_PATH/win_64
}
}
win32:!contains(QMAKE_TARGET.arch, x86_64):{
CONFIG(debug, debug|release) {
    DESTDIR = $$DESTINATION_SDK_PATH/win_32/DEBUG
} else {
    DESTDIR = $$DESTINATION_SDK_PATH/win_32
}
}

linux-g++ | linux-g++-64 | linux-g++-32:contains(QMAKE_HOST.arch, x86_64):{
    DESTDIR = $$DESTINATION_SDK_PATH/linux_64
}
linux-g++ | linux-g++-64 | linux-g++-32:!contains(QMAKE_HOST.arch, x86_64):{
    DESTDIR = $$DESTINATION_SDK_PATH/linux_32
}

mac {
    DESTDIR = $$DESTINATION_SDK_PATH/mac_64
}
############### destination path ###############

DEFINES +=  UNICODE \
        _UNICODE 

CONFIG(debug, debug|release){

message(Debug)
DEFINES += _DEBUG
}

#################### WINDOWS #####################
win32 {
    DEFINES += \
        LIBXML_READER_ENABLED

INCLUDEPATH += C:/boost_1_58_0
}
#################### WINDOWS #####################

#################### LINUX ########################
linux-g++ | linux-g++-64 | linux-g++-32 {
    DEFINES += \
        LINUX \
        _LINUX \
        _LINUX_QT
}

mac {
    DEFINES += \
        LINUX \
        _LINUX \
        _LINUX_QT \
        _MAC \
        MAC \
        _ASC_USE_UNICODE_CONVERTER_ \
        UNICODECONVERTER_USE_DYNAMIC_LIBRARY

INCLUDEPATH += ../../../Common/boost_1_58_0

LIBS += $$DESTDIR -lUnicodeConverter
}
#################### LINUX ########################
INCLUDEPATH += ../../../DesktopEditor/freetype-2.5.2/include
INCLUDEPATH += ../XlsFormat
INCLUDEPATH += ../Common

build_fast {
SOURCES += \
    xlsformatlib_logic.cpp \
    xlsformatlib_converter.cpp
} else {
SOURCES +=  \
    ../XlsFormat/Logic/Biff_records/AlRuns.cpp \
    ../XlsFormat/Logic/Biff_records/Area.cpp \
    ../XlsFormat/Logic/Biff_records/AreaFormat.cpp \
    ../XlsFormat/Logic/Biff_records/Array.cpp \
    ../XlsFormat/Logic/Biff_records/AttachedLabel.cpp \
    ../XlsFormat/Logic/Biff_records/AutoFilter.cpp \
    ../XlsFormat/Logic/Biff_records/AutoFilter12.cpp \
    ../XlsFormat/Logic/Biff_records/AutoFilterInfo.cpp \
    ../XlsFormat/Logic/Biff_records/AxcExt.cpp \
    ../XlsFormat/Logic/Biff_records/AxesUsed.cpp \
    ../XlsFormat/Logic/Biff_records/Axis.cpp \
    ../XlsFormat/Logic/Biff_records/AxisLine.cpp \
    ../XlsFormat/Logic/Biff_records/AxisParent.cpp \
    ../XlsFormat/Logic/Biff_records/Backup.cpp \
    ../XlsFormat/Logic/Biff_records/Bar.cpp \
    ../XlsFormat/Logic/Biff_records/Begin.cpp \
    ../XlsFormat/Logic/Biff_records/BiffRecord.cpp \
    ../XlsFormat/Logic/Biff_records/BiffRecordContinued.cpp \
    ../XlsFormat/Logic/Biff_records/BiffRecordSplit.cpp \
    ../XlsFormat/Logic/Biff_records/BigName.cpp \
    ../XlsFormat/Logic/Biff_records/BkHim.cpp \
    ../XlsFormat/Logic/Biff_records/Blank.cpp \
    ../XlsFormat/Logic/Biff_records/BOF.cpp \
    ../XlsFormat/Logic/Biff_records/BookBool.cpp \
    ../XlsFormat/Logic/Biff_records/BookExt.cpp \
    ../XlsFormat/Logic/Biff_records/BoolErr.cpp \
    ../XlsFormat/Logic/Biff_records/BopPop.cpp \
    ../XlsFormat/Logic/Biff_records/BopPopCustom.cpp \
    ../XlsFormat/Logic/Biff_records/BottomMargin.cpp \
    ../XlsFormat/Logic/Biff_records/BoundSheet8.cpp \
    ../XlsFormat/Logic/Biff_records/BRAI.cpp \
    ../XlsFormat/Logic/Biff_records/BuiltInFnGroupCount.cpp \
    ../XlsFormat/Logic/Biff_records/CalcCount.cpp \
    ../XlsFormat/Logic/Biff_records/CalcDelta.cpp \
    ../XlsFormat/Logic/Biff_records/CalcIter.cpp \
    ../XlsFormat/Logic/Biff_records/CalcMode.cpp \
    ../XlsFormat/Logic/Biff_records/CalcPrecision.cpp \
    ../XlsFormat/Logic/Biff_records/CalcRefMode.cpp \
    ../XlsFormat/Logic/Biff_records/CalcSaveRecalc.cpp \
    ../XlsFormat/Logic/Biff_records/CatLab.cpp \
    ../XlsFormat/Logic/Biff_records/CatSerRange.cpp \
    ../XlsFormat/Logic/Biff_records/CellWatch.cpp \
    ../XlsFormat/Logic/Biff_records/CF.cpp \
    ../XlsFormat/Logic/Biff_records/CF12.cpp \
    ../XlsFormat/Logic/Biff_records/CFEx.cpp \
    ../XlsFormat/Logic/Biff_records/Chart.cpp \
    ../XlsFormat/Logic/Biff_records/Chart3d.cpp \
    ../XlsFormat/Logic/Biff_records/Chart3DBarShape.cpp \
    ../XlsFormat/Logic/Biff_records/ChartFormat.cpp \
    ../XlsFormat/Logic/Biff_records/ChartFrtInfo.cpp \
    ../XlsFormat/Logic/Biff_records/CodeName.cpp \
    ../XlsFormat/Logic/Biff_records/CodePage.cpp \
    ../XlsFormat/Logic/Biff_records/ColInfo.cpp \
    ../XlsFormat/Logic/Biff_records/Compat12.cpp \
    ../XlsFormat/Logic/Biff_records/CompressPictures.cpp \
    ../XlsFormat/Logic/Biff_records/CondFmt.cpp \
    ../XlsFormat/Logic/Biff_records/CondFmt12.cpp \
    ../XlsFormat/Logic/Biff_records/Continue.cpp \
    ../XlsFormat/Logic/Biff_records/ContinueBigName.cpp \
    ../XlsFormat/Logic/Biff_records/ContinueFrt.cpp \
    ../XlsFormat/Logic/Biff_records/ContinueFrt11.cpp \
    ../XlsFormat/Logic/Biff_records/ContinueFrt12.cpp \
    ../XlsFormat/Logic/Biff_records/Country.cpp \
    ../XlsFormat/Logic/Biff_records/CrErr.cpp \
    ../XlsFormat/Logic/Biff_records/CRN.cpp \
    ../XlsFormat/Logic/Biff_records/CrtLayout12.cpp \
    ../XlsFormat/Logic/Biff_records/CrtLayout12A.cpp \
    ../XlsFormat/Logic/Biff_records/CrtLine.cpp \
    ../XlsFormat/Logic/Biff_records/CrtLink.cpp \
    ../XlsFormat/Logic/Biff_records/CrtMlFrt.cpp \
    ../XlsFormat/Logic/Biff_records/CrtMlFrtContinue.cpp \
    ../XlsFormat/Logic/Biff_records/Dat.cpp \
    ../XlsFormat/Logic/Biff_records/DataFormat.cpp \
    ../XlsFormat/Logic/Biff_records/DataLabExt.cpp \
    ../XlsFormat/Logic/Biff_records/DataLabExtContents.cpp \
    ../XlsFormat/Logic/Biff_records/Date1904.cpp \
    ../XlsFormat/Logic/Biff_records/DBCell.cpp \
    ../XlsFormat/Logic/Biff_records/DbOrParamQry.cpp \
    ../XlsFormat/Logic/Biff_records/DBQueryExt.cpp \
    ../XlsFormat/Logic/Biff_records/DCon.cpp \
    ../XlsFormat/Logic/Biff_records/DConBin.cpp \
    ../XlsFormat/Logic/Biff_records/DConn.cpp \
    ../XlsFormat/Logic/Biff_records/DConName.cpp \
    ../XlsFormat/Logic/Biff_records/DConRef.cpp \
    ../XlsFormat/Logic/Biff_records/DefaultRowHeight.cpp \
    ../XlsFormat/Logic/Biff_records/DefaultText.cpp \
    ../XlsFormat/Logic/Biff_records/DefColWidth.cpp \
    ../XlsFormat/Logic/Biff_records/Dimensions.cpp \
    ../XlsFormat/Logic/Biff_records/DocRoute.cpp \
    ../XlsFormat/Logic/Biff_records/DropBar.cpp \
    ../XlsFormat/Logic/Biff_records/DropDownObjIds.cpp \
    ../XlsFormat/Logic/Biff_records/DSF.cpp \
    ../XlsFormat/Logic/Biff_records/Dv.cpp \
    ../XlsFormat/Logic/Biff_records/DVal.cpp \
    ../XlsFormat/Logic/Biff_records/DXF.cpp \
    ../XlsFormat/Logic/Biff_records/DxGCol.cpp \
    ../XlsFormat/Logic/Biff_records/End.cpp \
    ../XlsFormat/Logic/Biff_records/EndObject.cpp \
    ../XlsFormat/Logic/Biff_records/EntExU2.cpp \
    ../XlsFormat/Logic/Biff_records/EOF.cpp \
    ../XlsFormat/Logic/Biff_records/Excel9File.cpp \
    ../XlsFormat/Logic/Biff_records/ExternName.cpp \
    ../XlsFormat/Logic/Biff_records/ExternSheet.cpp \
    ../XlsFormat/Logic/Biff_records/ExtSST.cpp \
    ../XlsFormat/Logic/Biff_records/ExtString.cpp \
    ../XlsFormat/Logic/Biff_records/Fbi.cpp \
    ../XlsFormat/Logic/Biff_records/Fbi2.cpp \
    ../XlsFormat/Logic/Biff_records/Feat.cpp \
    ../XlsFormat/Logic/Biff_records/FeatHdr.cpp \
    ../XlsFormat/Logic/Biff_records/FeatHdr11.cpp \
    ../XlsFormat/Logic/Biff_records/Feature11.cpp \
    ../XlsFormat/Logic/Biff_records/Feature12.cpp \
    ../XlsFormat/Logic/Biff_records/FilePass.cpp \
    ../XlsFormat/Logic/Biff_records/FileSharing.cpp \
    ../XlsFormat/Logic/Biff_records/FilterMode.cpp \
    ../XlsFormat/Logic/Biff_records/FnGroupName.cpp \
    ../XlsFormat/Logic/Biff_records/FnGrp12.cpp \
    ../XlsFormat/Logic/Biff_records/Font.cpp \
    ../XlsFormat/Logic/Biff_records/FontX.cpp \
    ../XlsFormat/Logic/Biff_records/Footer.cpp \
    ../XlsFormat/Logic/Biff_records/ForceFullCalculation.cpp \
    ../XlsFormat/Logic/Biff_records/Format.cpp \
    ../XlsFormat/Logic/Biff_records/Formula.cpp \
    ../XlsFormat/Logic/Biff_records/Frame.cpp \
    ../XlsFormat/Logic/Biff_records/FrtFontList.cpp \
    ../XlsFormat/Logic/Biff_records/GelFrame.cpp \
    ../XlsFormat/Logic/Biff_records/GridSet.cpp \
    ../XlsFormat/Logic/Biff_records/GUIDTypeLib.cpp \
    ../XlsFormat/Logic/Biff_records/Guts.cpp \
    ../XlsFormat/Logic/Biff_records/HCenter.cpp \
    ../XlsFormat/Logic/Biff_records/Header.cpp \
    ../XlsFormat/Logic/Biff_records/HeaderFooter.cpp \
    ../XlsFormat/Logic/Biff_records/HFPicture.cpp \
    ../XlsFormat/Logic/Biff_records/HideObj.cpp \
    ../XlsFormat/Logic/Biff_records/HLink.cpp \
    ../XlsFormat/Logic/Biff_records/HLinkTooltip.cpp \
    ../XlsFormat/Logic/Biff_records/HorizontalPageBreaks.cpp \
    ../XlsFormat/Logic/Biff_records/IFmtRecord.cpp \
    ../XlsFormat/Logic/Biff_records/Index.cpp \
    ../XlsFormat/Logic/Biff_records/InterfaceEnd.cpp \
    ../XlsFormat/Logic/Biff_records/InterfaceHdr.cpp \
    ../XlsFormat/Logic/Biff_records/Intl.cpp \
    ../XlsFormat/Logic/Biff_records/Label.cpp \
    ../XlsFormat/Logic/Biff_records/LabelSst.cpp \
    ../XlsFormat/Logic/Biff_records/Lbl.cpp \
    ../XlsFormat/Logic/Biff_records/LeftMargin.cpp \
    ../XlsFormat/Logic/Biff_records/Legend.cpp \
    ../XlsFormat/Logic/Biff_records/LegendException.cpp \
    ../XlsFormat/Logic/Biff_records/Lel.cpp \
    ../XlsFormat/Logic/Biff_records/Line.cpp \
    ../XlsFormat/Logic/Biff_records/LineFormat.cpp \
    ../XlsFormat/Logic/Biff_records/List12.cpp \
    ../XlsFormat/Logic/Biff_records/LPr.cpp \
    ../XlsFormat/Logic/Biff_records/LRng.cpp \
    ../XlsFormat/Logic/Biff_records/MarkerFormat.cpp \
    ../XlsFormat/Logic/Biff_records/MDB.cpp \
    ../XlsFormat/Logic/Biff_records/MDTInfo.cpp \
    ../XlsFormat/Logic/Biff_records/MDXKPI.cpp \
    ../XlsFormat/Logic/Biff_records/MDXProp.cpp \
    ../XlsFormat/Logic/Biff_records/MDXSet.cpp \
    ../XlsFormat/Logic/Biff_records/MDXStr.cpp \
    ../XlsFormat/Logic/Biff_records/MDXTuple.cpp \
    ../XlsFormat/Logic/Biff_records/MergeCells.cpp \
    ../XlsFormat/Logic/Biff_records/Mms.cpp \
    ../XlsFormat/Logic/Biff_records/MsoDrawing.cpp \
    ../XlsFormat/Logic/Biff_records/MsoDrawingGroup.cpp \
    ../XlsFormat/Logic/Biff_records/MsoDrawingSelection.cpp \
    ../XlsFormat/Logic/Biff_records/MTRSettings.cpp \
    ../XlsFormat/Logic/Biff_records/MulBlank.cpp \
    ../XlsFormat/Logic/Biff_records/MulRk.cpp \
    ../XlsFormat/Logic/Biff_records/NameCmt.cpp \
    ../XlsFormat/Logic/Biff_records/NameFnGrp12.cpp \
    ../XlsFormat/Logic/Biff_records/NamePublish.cpp \
    ../XlsFormat/Logic/Biff_records/Note.cpp \
    ../XlsFormat/Logic/Biff_records/Number.cpp \
    ../XlsFormat/Logic/Biff_records/Obj.cpp \
    ../XlsFormat/Logic/Biff_records/ObjectLink.cpp \
    ../XlsFormat/Logic/Biff_records/ObjProtect.cpp \
    ../XlsFormat/Logic/Biff_records/ObNoMacros.cpp \
    ../XlsFormat/Logic/Biff_records/ObProj.cpp \
    ../XlsFormat/Logic/Biff_records/OleDbConn.cpp \
    ../XlsFormat/Logic/Biff_records/OleObjectSize.cpp \
    ../XlsFormat/Logic/Biff_records/Palette.cpp \
    ../XlsFormat/Logic/Biff_records/Pane.cpp \
    ../XlsFormat/Logic/Biff_records/Password.cpp \
    ../XlsFormat/Logic/Biff_records/PhoneticInfo.cpp \
    ../XlsFormat/Logic/Biff_records/PicF.cpp \
    ../XlsFormat/Logic/Biff_records/Pie.cpp \
    ../XlsFormat/Logic/Biff_records/PieFormat.cpp \
    ../XlsFormat/Logic/Biff_records/PivotChartBits.cpp \
    ../XlsFormat/Logic/Biff_records/PlotArea.cpp \
    ../XlsFormat/Logic/Biff_records/PlotGrowth.cpp \
    ../XlsFormat/Logic/Biff_records/Pls.cpp \
    ../XlsFormat/Logic/Biff_records/PLV.cpp \
    ../XlsFormat/Logic/Biff_records/Pos.cpp \
    ../XlsFormat/Logic/Biff_records/PrintGrid.cpp \
    ../XlsFormat/Logic/Biff_records/PrintRowCol.cpp \
    ../XlsFormat/Logic/Biff_records/PrintSize.cpp \
    ../XlsFormat/Logic/Biff_records/Prot4Rev.cpp \
    ../XlsFormat/Logic/Biff_records/Prot4RevPass.cpp \
    ../XlsFormat/Logic/Biff_records/Protect.cpp \
    ../XlsFormat/Logic/Biff_records/Qsi.cpp \
    ../XlsFormat/Logic/Biff_records/Qsif.cpp \
    ../XlsFormat/Logic/Biff_records/Qsir.cpp \
    ../XlsFormat/Logic/Biff_records/QsiSXTag.cpp \
    ../XlsFormat/Logic/Biff_records/Radar.cpp \
    ../XlsFormat/Logic/Biff_records/RadarArea.cpp \
    ../XlsFormat/Logic/Biff_records/RealTimeData.cpp \
    ../XlsFormat/Logic/Biff_records/RecalcId.cpp \
    ../XlsFormat/Logic/Biff_records/RecipName.cpp \
    ../XlsFormat/Logic/Biff_records/RefreshAll.cpp \
    ../XlsFormat/Logic/Biff_records/RichTextStream.cpp \
    ../XlsFormat/Logic/Biff_records/RightMargin.cpp \
    ../XlsFormat/Logic/Biff_records/RK.cpp \
    ../XlsFormat/Logic/Biff_records/Row.cpp \
    ../XlsFormat/Logic/Biff_records/RRSort.cpp \
    ../XlsFormat/Logic/Biff_records/RRTabId.cpp \
    ../XlsFormat/Logic/Biff_records/SBaseRef.cpp \
    ../XlsFormat/Logic/Biff_records/Scatter.cpp \
    ../XlsFormat/Logic/Biff_records/SCENARIO.cpp \
    ../XlsFormat/Logic/Biff_records/ScenarioProtect.cpp \
    ../XlsFormat/Logic/Biff_records/ScenMan.cpp \
    ../XlsFormat/Logic/Biff_records/Scl.cpp \
    ../XlsFormat/Logic/Biff_records/Selection.cpp \
    ../XlsFormat/Logic/Biff_records/SerAuxErrBar.cpp \
    ../XlsFormat/Logic/Biff_records/SerAuxTrend.cpp \
    ../XlsFormat/Logic/Biff_records/SerFmt.cpp \
    ../XlsFormat/Logic/Biff_records/Series.cpp \
    ../XlsFormat/Logic/Biff_records/SeriesList.cpp \
    ../XlsFormat/Logic/Biff_records/SeriesText.cpp \
    ../XlsFormat/Logic/Biff_records/SerParent.cpp \
    ../XlsFormat/Logic/Biff_records/SerToCrt.cpp \
    ../XlsFormat/Logic/Biff_records/Setup.cpp \
    ../XlsFormat/Logic/Biff_records/ShapePropsStream.cpp \
    ../XlsFormat/Logic/Biff_records/SheetExt.cpp \
    ../XlsFormat/Logic/Biff_records/ShrFmla.cpp \
    ../XlsFormat/Logic/Biff_records/ShtProps.cpp \
    ../XlsFormat/Logic/Biff_records/SIIndex.cpp \
    ../XlsFormat/Logic/Biff_records/Sort.cpp \
    ../XlsFormat/Logic/Biff_records/SortData.cpp \
    ../XlsFormat/Logic/Biff_records/SST.cpp \
    ../XlsFormat/Logic/Biff_records/StartObject.cpp \
    ../XlsFormat/Logic/Biff_records/String.cpp \
    ../XlsFormat/Logic/Biff_records/Style.cpp \
    ../XlsFormat/Logic/Biff_records/StyleExt.cpp \
    ../XlsFormat/Logic/Biff_records/SupBook.cpp \
    ../XlsFormat/Logic/Biff_records/Surf.cpp \
    ../XlsFormat/Logic/Biff_records/SXAddl.cpp \
    ../XlsFormat/Logic/Biff_records/SXDI.cpp \
    ../XlsFormat/Logic/Biff_records/SxDXF.cpp \
    ../XlsFormat/Logic/Biff_records/SXEx.cpp \
    ../XlsFormat/Logic/Biff_records/SxFilt.cpp \
    ../XlsFormat/Logic/Biff_records/SxFormat.cpp \
    ../XlsFormat/Logic/Biff_records/SxItm.cpp \
    ../XlsFormat/Logic/Biff_records/SxIvd.cpp \
    ../XlsFormat/Logic/Biff_records/SXLI.cpp \
    ../XlsFormat/Logic/Biff_records/SXPI.cpp \
    ../XlsFormat/Logic/Biff_records/SXPIEx.cpp \
    ../XlsFormat/Logic/Biff_records/SxRule.cpp \
    ../XlsFormat/Logic/Biff_records/SxSelect.cpp \
    ../XlsFormat/Logic/Biff_records/SXStreamID.cpp \
    ../XlsFormat/Logic/Biff_records/SXString.cpp \
    ../XlsFormat/Logic/Biff_records/SXTbl.cpp \
    ../XlsFormat/Logic/Biff_records/SxTbpg.cpp \
    ../XlsFormat/Logic/Biff_records/SXTBRGIITM.cpp \
    ../XlsFormat/Logic/Biff_records/SXTH.cpp \
    ../XlsFormat/Logic/Biff_records/Sxvd.cpp \
    ../XlsFormat/Logic/Biff_records/SXVDEx.cpp \
    ../XlsFormat/Logic/Biff_records/SXVDTEx.cpp \
    ../XlsFormat/Logic/Biff_records/SXVI.cpp \
    ../XlsFormat/Logic/Biff_records/SxView.cpp \
    ../XlsFormat/Logic/Biff_records/SXViewEx.cpp \
    ../XlsFormat/Logic/Biff_records/SXViewEx9.cpp \
    ../XlsFormat/Logic/Biff_records/SXViewLink.cpp \
    ../XlsFormat/Logic/Biff_records/SXVS.cpp \
    ../XlsFormat/Logic/Biff_records/Sync.cpp \
    ../XlsFormat/Logic/Biff_records/Table.cpp \
    ../XlsFormat/Logic/Biff_records/TableStyle.cpp \
    ../XlsFormat/Logic/Biff_records/TableStyleElement.cpp \
    ../XlsFormat/Logic/Biff_records/TableStyles.cpp \
    ../XlsFormat/Logic/Biff_records/Template.cpp \
    ../XlsFormat/Logic/Biff_records/Text.cpp \
    ../XlsFormat/Logic/Biff_records/TextPropsStream.cpp \
    ../XlsFormat/Logic/Biff_records/Theme.cpp \
    ../XlsFormat/Logic/Biff_records/Tick.cpp \
    ../XlsFormat/Logic/Biff_records/TopMargin.cpp \
    ../XlsFormat/Logic/Biff_records/TxO.cpp \
    ../XlsFormat/Logic/Biff_records/TxtQry.cpp \
    ../XlsFormat/Logic/Biff_records/Uncalced.cpp \
    ../XlsFormat/Logic/Biff_records/Units.cpp \
    ../XlsFormat/Logic/Biff_records/UserBView.cpp \
    ../XlsFormat/Logic/Biff_records/UserSViewBegin.cpp \
    ../XlsFormat/Logic/Biff_records/UserSViewEnd.cpp \
    ../XlsFormat/Logic/Biff_records/UsesELFs.cpp \
    ../XlsFormat/Logic/Biff_records/ValueRange.cpp \
    ../XlsFormat/Logic/Biff_records/VCenter.cpp \
    ../XlsFormat/Logic/Biff_records/VerticalPageBreaks.cpp \
    ../XlsFormat/Logic/Biff_records/WebPub.cpp \
    ../XlsFormat/Logic/Biff_records/Window1.cpp \
    ../XlsFormat/Logic/Biff_records/Window2.cpp \
    ../XlsFormat/Logic/Biff_records/WinProtect.cpp \
    ../XlsFormat/Logic/Biff_records/WOpt.cpp \
    ../XlsFormat/Logic/Biff_records/WriteAccess.cpp \
    ../XlsFormat/Logic/Biff_records/WriteProtect.cpp \
    ../XlsFormat/Logic/Biff_records/WsBool.cpp \
    ../XlsFormat/Logic/Biff_records/XCT.cpp \
    ../XlsFormat/Logic/Biff_records/XF.cpp \
    ../XlsFormat/Logic/Biff_records/XFCRC.cpp \
    ../XlsFormat/Logic/Biff_records/XFExt.cpp \
    ../XlsFormat/Logic/Biff_records/YMult.cpp \
    ../XlsFormat/Binary/CFRecord.cpp \
    ../XlsFormat/Binary/CFRecordType.cpp \
    ../XlsFormat/Binary/CFStream.cpp \
    ../XlsFormat/Binary/CFStreamCacheReader.cpp \
    ../XlsFormat/Binary/CFStreamCacheWriter.cpp \
    ../XlsFormat/Binary/CompoundFile.cpp \
    ../XlsFormat/Crypt/rtl/cipher.cpp \
    ../XlsFormat/Crypt/rtl/digest.cpp \
    ../XlsFormat/Crypt/BiffDecoder_RCF.cpp \
    ../XlsFormat/Crypt/BinaryCodec_RCF.cpp \
    ../XlsFormat/Crypt/Decryptor.cpp \
    ../XlsFormat/Crypt/RC4Crypt.cpp \
    ../XlsFormat/Logging/Log.cpp \
    ../XlsFormat/Logging/Logger.cpp \
    ../XlsFormat/Logic/Biff_structures/AddinUdf.cpp \
    ../XlsFormat/Logic/Biff_structures/AF12Criteria.cpp \
    ../XlsFormat/Logic/Biff_structures/AFDOper.cpp \
    ../XlsFormat/Logic/Biff_structures/AFDOperRk.cpp \
    ../XlsFormat/Logic/Biff_structures/AFDOperStr.cpp \
    ../XlsFormat/Logic/Biff_structures/AntiMoniker.cpp \
    ../XlsFormat/Logic/Biff_structures/ArrayParsedFormula.cpp \
    ../XlsFormat/Logic/Biff_structures/Bes.cpp \
    ../XlsFormat/Logic/Biff_structures/BiffString.cpp \
    ../XlsFormat/Logic/Biff_structures/BiffStructure.cpp \
    ../XlsFormat/Logic/Biff_structures/BookExt_Conditional11.cpp \
    ../XlsFormat/Logic/Biff_structures/BookExt_Conditional12.cpp \
    ../XlsFormat/Logic/Biff_structures/BorderFillInfo.cpp \
    ../XlsFormat/Logic/Biff_structures/BuiltInStyle.cpp \
    ../XlsFormat/Logic/Biff_structures/Cell.cpp \
    ../XlsFormat/Logic/Biff_structures/CellOffsetResender.cpp \
    ../XlsFormat/Logic/Biff_structures/CellParsedFormula.cpp \
    ../XlsFormat/Logic/Biff_structures/CellRangeRef.cpp \
    ../XlsFormat/Logic/Biff_structures/CellRef.cpp \
    ../XlsFormat/Logic/Biff_structures/CellXF.cpp \
    ../XlsFormat/Logic/Biff_structures/Cetab.cpp \
    ../XlsFormat/Logic/Biff_structures/CFColor.cpp \
    ../XlsFormat/Logic/Biff_structures/CFExNonCF12.cpp \
    ../XlsFormat/Logic/Biff_structures/CFExTemplateParams.cpp \
    ../XlsFormat/Logic/Biff_structures/CFMStateItem.cpp \
    ../XlsFormat/Logic/Biff_structures/CFMultistate.cpp \
    ../XlsFormat/Logic/Biff_structures/CFParsedFormula.cpp \
    ../XlsFormat/Logic/Biff_structures/CFParsedFormulaNoCCE.cpp \
    ../XlsFormat/Logic/Biff_structures/CFVO.cpp \
    ../XlsFormat/Logic/Biff_structures/CFVOParsedFormula.cpp \
    ../XlsFormat/Logic/Biff_structures/ChartNumNillable.cpp \
    ../XlsFormat/Logic/Biff_structures/ChartParsedFormula.cpp \
    ../XlsFormat/Logic/Biff_structures/CompositeMoniker.cpp \
    ../XlsFormat/Logic/Biff_structures/CondFmtStructure.cpp \
    ../XlsFormat/Logic/Biff_structures/ControlInfo.cpp \
    ../XlsFormat/Logic/Biff_structures/DropDownObjId.cpp \
    ../XlsFormat/Logic/Biff_structures/DVParsedFormula.cpp \
    ../XlsFormat/Logic/Biff_structures/DXFALC.cpp \
    ../XlsFormat/Logic/Biff_structures/DXFBdr.cpp \
    ../XlsFormat/Logic/Biff_structures/DXFFntD.cpp \
    ../XlsFormat/Logic/Biff_structures/DXFId.cpp \
    ../XlsFormat/Logic/Biff_structures/DXFN.cpp \
    ../XlsFormat/Logic/Biff_structures/DXFN12.cpp \
    ../XlsFormat/Logic/Biff_structures/DXFN12List.cpp \
    ../XlsFormat/Logic/Biff_structures/DXFNum.cpp \
    ../XlsFormat/Logic/Biff_structures/DXFNumUsr.cpp \
    ../XlsFormat/Logic/Biff_structures/DXFPat.cpp \
    ../XlsFormat/Logic/Biff_structures/DXFProt.cpp \
    ../XlsFormat/Logic/Biff_structures/EncryptionHeader.cpp \
    ../XlsFormat/Logic/Biff_structures/EncryptionHeaderFlags.cpp \
    ../XlsFormat/Logic/Biff_structures/EncryptionVerifier.cpp \
    ../XlsFormat/Logic/Biff_structures/EnhancedProtection.cpp \
    ../XlsFormat/Logic/Biff_structures/ExternDdeLinkNoOper.cpp \
    ../XlsFormat/Logic/Biff_structures/ExternDocName.cpp \
    ../XlsFormat/Logic/Biff_structures/ExternOleDdeLink.cpp \
    ../XlsFormat/Logic/Biff_structures/ExtNameParsedFormula.cpp \
    ../XlsFormat/Logic/Biff_structures/ExtProp.cpp \
    ../XlsFormat/Logic/Biff_structures/ExtPtgArea3D.cpp \
    ../XlsFormat/Logic/Biff_structures/ExtPtgAreaErr3D.cpp \
    ../XlsFormat/Logic/Biff_structures/ExtPtgErr.cpp \
    ../XlsFormat/Logic/Biff_structures/ExtPtgRef3D.cpp \
    ../XlsFormat/Logic/Biff_structures/ExtPtgRefErr3D.cpp \
    ../XlsFormat/Logic/Biff_structures/ExtRst.cpp \
    ../XlsFormat/Logic/Biff_structures/FactoidData.cpp \
    ../XlsFormat/Logic/Biff_structures/FactoidType.cpp \
    ../XlsFormat/Logic/Biff_structures/Feat11FdaAutoFilter.cpp \
    ../XlsFormat/Logic/Biff_structures/Feat11FieldDataItem.cpp \
    ../XlsFormat/Logic/Biff_structures/FeatFormulaErr2.cpp \
    ../XlsFormat/Logic/Biff_structures/FeatProtection.cpp \
    ../XlsFormat/Logic/Biff_structures/FeatSmartTag.cpp \
    ../XlsFormat/Logic/Biff_structures/FileMoniker.cpp \
    ../XlsFormat/Logic/Biff_structures/FileOffset.cpp \
    ../XlsFormat/Logic/Biff_structures/FilePointer.cpp \
    ../XlsFormat/Logic/Biff_structures/FixedPoint.cpp \
    ../XlsFormat/Logic/Biff_structures/FontIndex.cpp \
    ../XlsFormat/Logic/Biff_structures/FormatRun.cpp \
    ../XlsFormat/Logic/Biff_structures/FormulaValue.cpp \
    ../XlsFormat/Logic/Biff_structures/FrtHeader.cpp \
    ../XlsFormat/Logic/Biff_structures/FrtHeaderOld.cpp \
    ../XlsFormat/Logic/Biff_structures/FrtRefHeader.cpp \
    ../XlsFormat/Logic/Biff_structures/FrtRefHeaderNoGrbit.cpp \
    ../XlsFormat/Logic/Biff_structures/FrtRefHeaderU.cpp \
    ../XlsFormat/Logic/Biff_structures/Ftab_Cetab.cpp \
    ../XlsFormat/Logic/Biff_structures/FtCblsData.cpp \
    ../XlsFormat/Logic/Biff_structures/FtCf.cpp \
    ../XlsFormat/Logic/Biff_structures/FtCmo.cpp \
    ../XlsFormat/Logic/Biff_structures/FtEdoData.cpp \
    ../XlsFormat/Logic/Biff_structures/FtGboData.cpp \
    ../XlsFormat/Logic/Biff_structures/FtLbsData.cpp \
    ../XlsFormat/Logic/Biff_structures/FtMacro.cpp \
    ../XlsFormat/Logic/Biff_structures/FtNts.cpp \
    ../XlsFormat/Logic/Biff_structures/FtPictFmla.cpp \
    ../XlsFormat/Logic/Biff_structures/FtPioGrbit.cpp \
    ../XlsFormat/Logic/Biff_structures/FtRboData.cpp \
    ../XlsFormat/Logic/Biff_structures/FtSbs.cpp \
    ../XlsFormat/Logic/Biff_structures/FullColorExt.cpp \
    ../XlsFormat/Logic/Biff_structures/GradStop.cpp \
    ../XlsFormat/Logic/Biff_structures/HideObjEnum.cpp \
    ../XlsFormat/Logic/Biff_structures/HorzBrk.cpp \
    ../XlsFormat/Logic/Biff_structures/HyperlinkMoniker.cpp \
    ../XlsFormat/Logic/Biff_structures/HyperlinkObject.cpp \
    ../XlsFormat/Logic/Biff_structures/ISSTInf.cpp \
    ../XlsFormat/Logic/Biff_structures/ItemMoniker.cpp \
    ../XlsFormat/Logic/Biff_structures/LbsDropData.cpp \
    ../XlsFormat/Logic/Biff_structures/List12BlockLevel.cpp \
    ../XlsFormat/Logic/Biff_structures/List12DisplayName.cpp \
    ../XlsFormat/Logic/Biff_structures/List12TableStyleClientInfo.cpp \
    ../XlsFormat/Logic/Biff_structures/LongRGB.cpp \
    ../XlsFormat/Logic/Biff_structures/MDir.cpp \
    ../XlsFormat/Logic/Biff_structures/MDXStrIndex.cpp \
    ../XlsFormat/Logic/Biff_structures/MOper.cpp \
    ../XlsFormat/Logic/Biff_structures/NameParsedFormula.cpp \
    ../XlsFormat/Logic/Biff_structures/NoteRR.cpp \
    ../XlsFormat/Logic/Biff_structures/NoteSh.cpp \
    ../XlsFormat/Logic/Biff_structures/ObjectParsedFormula.cpp \
    ../XlsFormat/Logic/Biff_structures/ObjFmla.cpp \
    ../XlsFormat/Logic/Biff_structures/ObjLinkFmla.cpp \
    ../XlsFormat/Logic/Biff_structures/PaneType.cpp \
    ../XlsFormat/Logic/Biff_structures/ParsedFormula.cpp \
    ../XlsFormat/Logic/Biff_structures/PhRuns.cpp \
    ../XlsFormat/Logic/Biff_structures/Phs.cpp \
    ../XlsFormat/Logic/Biff_structures/PictFmlaEmbedInfo.cpp \
    ../XlsFormat/Logic/Biff_structures/PictFmlaKey.cpp \
    ../XlsFormat/Logic/Biff_structures/PropertyBag.cpp \
    ../XlsFormat/Logic/Biff_structures/PropertyBagStore.cpp \
    ../XlsFormat/Logic/Biff_structures/Ptg.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgArea.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgArea3d.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgAreaErr.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgAreaErr3d.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgAreaN.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgArray.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgAttrBaxcel.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgAttrChoose.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgAttrGoto.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgAttrIf.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgAttrSemi.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgAttrSpace.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgAttrSpaceSemi.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgAttrSum.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgBool.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgElfCol.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgElfColS.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgElfColSV.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgElfColV.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgElfLel.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgElfRadical.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgElfRadicalLel.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgElfRadicalS.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgElfRw.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgElfRwV.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgErr.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgExp.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgExtraArray.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgExtraElf.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgExtraMem.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgFactory.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgFunc.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgFuncVar.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgInt.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgMemArea.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgMemAreaN.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgMemErr.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgMemFunc.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgMemNoMem.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgMemNoMemN.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgMissArg.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgName.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgNameX.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgNum.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgParam.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgParen.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgRef.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgRef3d.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgRefErr.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgRefErr3d.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgRefN.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgStr.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgSxName.cpp \
    ../XlsFormat/Logic/Biff_structures/PtgTbl.cpp \
    ../XlsFormat/Logic/Biff_structures/RC4CryptoAPIEncryptionHeader.cpp \
    ../XlsFormat/Logic/Biff_structures/RC4EncryptionHeader.cpp \
    ../XlsFormat/Logic/Biff_structures/RevExtern.cpp \
    ../XlsFormat/Logic/Biff_structures/RevItab.cpp \
    ../XlsFormat/Logic/Biff_structures/RevLblName.cpp \
    ../XlsFormat/Logic/Biff_structures/RevName.cpp \
    ../XlsFormat/Logic/Biff_structures/RevNamePly.cpp \
    ../XlsFormat/Logic/Biff_structures/RevNameTabid.cpp \
    ../XlsFormat/Logic/Biff_structures/RgbExtra.cpp \
    ../XlsFormat/Logic/Biff_structures/Rgce.cpp \
    ../XlsFormat/Logic/Biff_structures/RkRec.cpp \
    ../XlsFormat/Logic/Biff_structures/RPHSSub.cpp \
    ../XlsFormat/Logic/Biff_structures/RRD.cpp \
    ../XlsFormat/Logic/Biff_structures/Run.cpp \
    ../XlsFormat/Logic/Biff_structures/SDContainer.cpp \
    ../XlsFormat/Logic/Biff_structures/SecurityDescriptor.cpp \
    ../XlsFormat/Logic/Biff_structures/SerAr.cpp \
    ../XlsFormat/Logic/Biff_structures/SerBool.cpp \
    ../XlsFormat/Logic/Biff_structures/SerErr.cpp \
    ../XlsFormat/Logic/Biff_structures/SerNil.cpp \
    ../XlsFormat/Logic/Biff_structures/SerNum.cpp \
    ../XlsFormat/Logic/Biff_structures/SerStr.cpp \
    ../XlsFormat/Logic/Biff_structures/SharedParsedFormula.cpp \
    ../XlsFormat/Logic/Biff_structures/SheetExtOptional.cpp \
    ../XlsFormat/Logic/Biff_structures/SheetId.cpp \
    ../XlsFormat/Logic/Biff_structures/SortCond12.cpp \
    ../XlsFormat/Logic/Biff_structures/SqRef.cpp \
    ../XlsFormat/Logic/Biff_structures/SqRefU.cpp \
    ../XlsFormat/Logic/Biff_structures/StringPtgParser.cpp \
    ../XlsFormat/Logic/Biff_structures/Stxp.cpp \
    ../XlsFormat/Logic/Biff_structures/StyleXF.cpp \
    ../XlsFormat/Logic/Biff_structures/SyntaxPtg.cpp \
    ../XlsFormat/Logic/Biff_structures/TableFeatureType.cpp \
    ../XlsFormat/Logic/Biff_structures/TxOLastRun.cpp \
    ../XlsFormat/Logic/Biff_structures/TxORuns.cpp \
    ../XlsFormat/Logic/Biff_structures/URICreateFlags.cpp \
    ../XlsFormat/Logic/Biff_structures/URLMoniker.cpp \
    ../XlsFormat/Logic/Biff_structures/VertBrk.cpp \
    ../XlsFormat/Logic/Biff_structures/XFExtGradient.cpp \
    ../XlsFormat/Logic/Biff_structures/XFExtNoFRT.cpp \
    ../XlsFormat/Logic/Biff_structures/XFProp.cpp \
    ../XlsFormat/Logic/Biff_structures/XFPropBorder.cpp \
    ../XlsFormat/Logic/Biff_structures/XFPropColor.cpp \
    ../XlsFormat/Logic/Biff_structures/XFPropGradient.cpp \
    ../XlsFormat/Logic/Biff_structures/XFPropGradientStop.cpp \
    ../XlsFormat/Logic/Biff_structures/XFProps.cpp \
    ../XlsFormat/Logic/Biff_structures/XLUnicodeRichExtendedString.cpp \
    ../XlsFormat/Logic/Biff_structures/XORObfuscation.cpp \
    ../XlsFormat/Logic/Biff_structures/XTI.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/MSOCR.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/MSOSHADECOLOR.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtBlip.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtBStoreContainer.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtBStoreContainerFileBlock.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtClientAnchorChart.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtClientAnchorHF.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtClientAnchorSheet.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtColorMRUContainer.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtCOLORREF.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtContainer.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtDgContainer.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtFDG.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtFDGGBlock.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtFOPT.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtFOPTE.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtFRIT.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtFRITContainer.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtFSP.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtFSPGR.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtIDCL.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtMetafileHeader.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtRecord.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtRecordHeader.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtRGFOPTE.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtSplitMenuColorContainer.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtTertiaryFOPT.cpp \
    ../XlsFormat/Logic/Biff_structures/ODRAW/SimpleOfficeArtContainers.cpp \
    ../XlsFormat/Logic/Biff_unions/AI.cpp \
    ../XlsFormat/Logic/Biff_unions/ATTACHEDLABEL_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/AUTOFILTER_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/AXES.cpp \
    ../XlsFormat/Logic/Biff_unions/AXISPARENT_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/AXM.cpp \
    ../XlsFormat/Logic/Biff_unions/AXS.cpp \
    ../XlsFormat/Logic/Biff_unions/BACKGROUND.cpp \
    ../XlsFormat/Logic/Biff_unions/BIGNAME_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/BUNDLESHEET.cpp \
    ../XlsFormat/Logic/Biff_unions/CELL_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/CELLTABLE.cpp \
    ../XlsFormat/Logic/Biff_unions/CHART_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/CHARTFOMATS.cpp \
    ../XlsFormat/Logic/Biff_unions/COLUMNS.cpp \
    ../XlsFormat/Logic/Biff_unions/CONDFMT_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/CONDFMT12_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/CONDFMTS.cpp \
    ../XlsFormat/Logic/Biff_unions/CRT.cpp \
    ../XlsFormat/Logic/Biff_unions/CRTMLFRT_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/CUSTOMVIEW.cpp \
    ../XlsFormat/Logic/Biff_unions/DAT_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/DBQUERY.cpp \
    ../XlsFormat/Logic/Biff_unions/DBQUERYEXT_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/DCON_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/DFTTEXT.cpp \
    ../XlsFormat/Logic/Biff_unions/DOCROUTE_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/DREF.cpp \
    ../XlsFormat/Logic/Biff_unions/DROPBAR_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/DVAL_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/DVAXIS.cpp \
    ../XlsFormat/Logic/Biff_unions/FEAT_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/FEAT11.cpp \
    ../XlsFormat/Logic/Biff_unions/FNGROUPS.cpp \
    ../XlsFormat/Logic/Biff_unions/FONTLIST.cpp \
    ../XlsFormat/Logic/Biff_unions/FORMATTING.cpp \
    ../XlsFormat/Logic/Biff_unions/FORMULA_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/FRAME_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/GELFRAME_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/GLOBALS.cpp \
    ../XlsFormat/Logic/Biff_unions/HLINK_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/INTERFACE.cpp \
    ../XlsFormat/Logic/Biff_unions/IVAXIS.cpp \
    ../XlsFormat/Logic/Biff_unions/LBL_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/LD.cpp \
    ../XlsFormat/Logic/Biff_unions/MACROSORTANDFILTER.cpp \
    ../XlsFormat/Logic/Biff_unions/MDBLOCK.cpp \
    ../XlsFormat/Logic/Biff_unions/MDTINFO_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/MDXSTR_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/MDXTUPLESET.cpp \
    ../XlsFormat/Logic/Biff_unions/METADATA.cpp \
    ../XlsFormat/Logic/Biff_unions/MSODRAWINGGROUP_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/OBJ_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/OBJECTS.cpp \
    ../XlsFormat/Logic/Biff_unions/PAGESETUP.cpp \
    ../XlsFormat/Logic/Biff_unions/PHONETICINFO_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/PICF_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/PIVOTADDL.cpp \
    ../XlsFormat/Logic/Biff_unions/PIVOTCACHEDEFINITION.cpp \
    ../XlsFormat/Logic/Biff_unions/PIVOTCORE.cpp \
    ../XlsFormat/Logic/Biff_unions/PIVOTEX.cpp \
    ../XlsFormat/Logic/Biff_unions/PIVOTFORMAT.cpp \
    ../XlsFormat/Logic/Biff_unions/PIVOTFRT.cpp \
    ../XlsFormat/Logic/Biff_unions/PIVOTFRT9.cpp \
    ../XlsFormat/Logic/Biff_unions/PIVOTIVD.cpp \
    ../XlsFormat/Logic/Biff_unions/PIVOTLI.cpp \
    ../XlsFormat/Logic/Biff_unions/PIVOTPI.cpp \
    ../XlsFormat/Logic/Biff_unions/PIVOTRULE.cpp \
    ../XlsFormat/Logic/Biff_unions/PIVOTSELECT.cpp \
    ../XlsFormat/Logic/Biff_unions/PIVOTTH.cpp \
    ../XlsFormat/Logic/Biff_unions/PIVOTVD.cpp \
    ../XlsFormat/Logic/Biff_unions/PIVOTVDTEX.cpp \
    ../XlsFormat/Logic/Biff_unions/PIVOTVIEW.cpp \
    ../XlsFormat/Logic/Biff_unions/PIVOTVIEWEX.cpp \
    ../XlsFormat/Logic/Biff_unions/PRFILTER.cpp \
    ../XlsFormat/Logic/Biff_unions/PROTECTION.cpp \
    ../XlsFormat/Logic/Biff_unions/PROTECTION_COMMON.cpp \
    ../XlsFormat/Logic/Biff_unions/QSIR_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/QUERYTABLE.cpp \
    ../XlsFormat/Logic/Biff_unions/RECORD12.cpp \
    ../XlsFormat/Logic/Biff_unions/RTD.cpp \
    ../XlsFormat/Logic/Biff_unions/SCENARIOS.cpp \
    ../XlsFormat/Logic/Biff_unions/SERIESAXIS.cpp \
    ../XlsFormat/Logic/Biff_unions/SERIESDATA.cpp \
    ../XlsFormat/Logic/Biff_unions/SERIESFORMAT.cpp \
    ../XlsFormat/Logic/Biff_unions/SHAPEPROPS.cpp \
    ../XlsFormat/Logic/Biff_unions/SHAREDSTRINGS.cpp \
    ../XlsFormat/Logic/Biff_unions/SHFMLA_SET.cpp \
    ../XlsFormat/Logic/Biff_unions/SORT_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/SORTANDFILTER.cpp \
    ../XlsFormat/Logic/Biff_unions/SORTDATA12.cpp \
    ../XlsFormat/Logic/Biff_unions/SS.cpp \
    ../XlsFormat/Logic/Biff_unions/STYLES.cpp \
    ../XlsFormat/Logic/Biff_unions/SUB.cpp \
    ../XlsFormat/Logic/Biff_unions/SUPBOOK_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLAUTOSORT.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLCACHE.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLCACHE12.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLCACHEFIELD.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLCACHEITEM.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLCALCMEMBER.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLCONDFMT.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLCONDFMTS.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLDBQUERY.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLFIELD.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLFIELD12.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLGROUP.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLGRPLEVEL.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLHIERARCHY.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLQSI.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLSXDH.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLSXFILT.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLSXFILTER12.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLSXFILTERS12.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLSXMG.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLSXMGS.cpp \
    ../XlsFormat/Logic/Biff_unions/SXADDLSXRULE.cpp \
    ../XlsFormat/Logic/Biff_unions/SXSRC.cpp \
    ../XlsFormat/Logic/Biff_unions/SXTBL_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/TABLESTYLES_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/TEXTOBJECT.cpp \
    ../XlsFormat/Logic/Biff_unions/TEXTPROPS.cpp \
    ../XlsFormat/Logic/Biff_unions/THEME_bu.cpp \
    ../XlsFormat/Logic/Biff_unions/UNKNOWNFRT.cpp \
    ../XlsFormat/Logic/Biff_unions/WINDOW.cpp \
    ../XlsFormat/Logic/Biff_unions/XFS.cpp \
    ../XlsFormat/Logic/SummaryInformationStream/Structures/Property_Structures.cpp \
    ../XlsFormat/Logic/SummaryInformationStream/Structures/PropertyFactory.cpp \
    ../XlsFormat/Logic/SummaryInformationStream/Structures/PropertySet.cpp \
    ../XlsFormat/Logic/SummaryInformationStream/Structures/PropertySetStream.cpp \
    ../XlsFormat/Logic/SummaryInformationStream/SummaryInformation.cpp \
    ../Common/utils.cpp \
    ../XlsXlsxConverter/ConvertXls2Xlsx.cpp \
    ../XlsXlsxConverter/external_items.cpp \
    ../XlsXlsxConverter/mediaitems_utils.cpp \
    ../XlsXlsxConverter/namespaces.cpp \
    ../XlsXlsxConverter/oox_content_type.cpp \
    ../XlsXlsxConverter/oox_package.cpp \
    ../XlsXlsxConverter/oox_rels.cpp \
    ../XlsXlsxConverter/XlsConverter.cpp \
    ../XlsXlsxConverter/xlsx_conversion_context.cpp \
    ../XlsXlsxConverter/xlsx_drawing_context.cpp \
    ../XlsXlsxConverter/xlsx_drawings.cpp \
    ../XlsXlsxConverter/xlsx_hyperlinks.cpp \
    ../XlsXlsxConverter/xlsx_output_xml.cpp \
    ../XlsXlsxConverter/xlsx_package.cpp \
    ../XlsXlsxConverter/xlsx_protection.cpp \
    ../XlsXlsxConverter/xlsx_tablecontext.cpp \
    ../XlsXlsxConverter/xlsx_textcontext.cpp \
    ../XlsXlsxConverter/xlsx_chart_context.cpp \
    ../XlsXlsxConverter/xlsx_comments.cpp \
    ../XlsXlsxConverter/xlsx_comments_context.cpp \
    ../XlsFormat/Logic/AnyObject.cpp \
    ../XlsFormat/Logic/AnySubstream.cpp \
    ../XlsFormat/Logic/BinProcessor.cpp \
    ../XlsFormat/Logic/ChartSheetSubstream.cpp \
    ../XlsFormat/Logic/CompositeObject.cpp \
    ../XlsFormat/Logic/GlobalsSubstream.cpp \
    ../XlsFormat/Logic/GlobalWorkbookInfo.cpp \
    ../XlsFormat/Logic/MacroSheetSubstream.cpp \
    ../XlsFormat/Logic/WorkbookStreamObject.cpp \
    ../XlsFormat/Logic/WorksheetSubstream.cpp \
    ../XlsFormat/Auxiliary/HelpFunc.cpp \
    ../XlsFormat/Logic/SummaryInformationStream/Structures/CodePageOle.cpp \
    ../XlsFormat/Logic/Biff_structures/SharedProperty.cpp \
    ../XlsFormat/Logic/Biff_records/FrtWrapper.cpp \
    ../XlsXlsxConverter/ConvertShapes/FormulaShape.cpp \
    ../XlsXlsxConverter/ConvertShapes/CustomShape.cpp \
    ../XlsXlsxConverter/ConvertShapes/BaseShape_1.cpp \
    ../XlsFormat/Logic/Biff_structures/AFDOperBoolErr.cpp \
    ../XlsFormat/Logic/Biff_structures/AFDOperXNum.cpp
}

HEADERS +=  \
    ../XlsFormat/Logic/Biff_records/AlRuns.h \
    ../XlsFormat/Logic/Biff_records/Area.h \
    ../XlsFormat/Logic/Biff_records/AreaFormat.h \
    ../XlsFormat/Logic/Biff_records/Array.h \
    ../XlsFormat/Logic/Biff_records/AttachedLabel.h \
    ../XlsFormat/Logic/Biff_records/AutoFilter.h \
    ../XlsFormat/Logic/Biff_records/AutoFilter12.h \
    ../XlsFormat/Logic/Biff_records/AutoFilterInfo.h \
    ../XlsFormat/Logic/Biff_records/AxcExt.h \
    ../XlsFormat/Logic/Biff_records/AxesUsed.h \
    ../XlsFormat/Logic/Biff_records/Axis.h \
    ../XlsFormat/Logic/Biff_records/AxisLine.h \
    ../XlsFormat/Logic/Biff_records/AxisParent.h \
    ../XlsFormat/Logic/Biff_records/Backup.h \
    ../XlsFormat/Logic/Biff_records/Bar.h \
    ../XlsFormat/Logic/Biff_records/Begin.h \
    ../XlsFormat/Logic/Biff_records/BiffRecord.h \
    ../XlsFormat/Logic/Biff_records/BiffRecordContinued.h \
    ../XlsFormat/Logic/Biff_records/BiffRecordSplit.h \
    ../XlsFormat/Logic/Biff_records/BigName.h \
    ../XlsFormat/Logic/Biff_records/BkHim.h \
    ../XlsFormat/Logic/Biff_records/Blank.h \
    ../XlsFormat/Logic/Biff_records/BOF.h \
    ../XlsFormat/Logic/Biff_records/BookBool.h \
    ../XlsFormat/Logic/Biff_records/BookExt.h \
    ../XlsFormat/Logic/Biff_records/BoolErr.h \
    ../XlsFormat/Logic/Biff_records/BopPop.h \
    ../XlsFormat/Logic/Biff_records/BopPopCustom.h \
    ../XlsFormat/Logic/Biff_records/BottomMargin.h \
    ../XlsFormat/Logic/Biff_records/BoundSheet8.h \
    ../XlsFormat/Logic/Biff_records/BRAI.h \
    ../XlsFormat/Logic/Biff_records/BuiltInFnGroupCount.h \
    ../XlsFormat/Logic/Biff_records/CalcCount.h \
    ../XlsFormat/Logic/Biff_records/CalcDelta.h \
    ../XlsFormat/Logic/Biff_records/CalcIter.h \
    ../XlsFormat/Logic/Biff_records/CalcMode.h \
    ../XlsFormat/Logic/Biff_records/CalcPrecision.h \
    ../XlsFormat/Logic/Biff_records/CalcRefMode.h \
    ../XlsFormat/Logic/Biff_records/CalcSaveRecalc.h \
    ../XlsFormat/Logic/Biff_records/CatLab.h \
    ../XlsFormat/Logic/Biff_records/CatSerRange.h \
    ../XlsFormat/Logic/Biff_records/CellWatch.h \
    ../XlsFormat/Logic/Biff_records/CF.h \
    ../XlsFormat/Logic/Biff_records/CF12.h \
    ../XlsFormat/Logic/Biff_records/CFEx.h \
    ../XlsFormat/Logic/Biff_records/Chart.h \
    ../XlsFormat/Logic/Biff_records/Chart3d.h \
    ../XlsFormat/Logic/Biff_records/Chart3DBarShape.h \
    ../XlsFormat/Logic/Biff_records/ChartFormat.h \
    ../XlsFormat/Logic/Biff_records/ChartFrtInfo.h \
    ../XlsFormat/Logic/Biff_records/ClrtClient.h \
    ../XlsFormat/Logic/Biff_records/CodeName.h \
    ../XlsFormat/Logic/Biff_records/CodePage.h \
    ../XlsFormat/Logic/Biff_records/ColInfo.h \
    ../XlsFormat/Logic/Biff_records/Compat12.h \
    ../XlsFormat/Logic/Biff_records/CompressPictures.h \
    ../XlsFormat/Logic/Biff_records/CondFmt.h \
    ../XlsFormat/Logic/Biff_records/CondFmt12.h \
    ../XlsFormat/Logic/Biff_records/Continue.h \
    ../XlsFormat/Logic/Biff_records/ContinueBigName.h \
    ../XlsFormat/Logic/Biff_records/ContinueFrt.h \
    ../XlsFormat/Logic/Biff_records/ContinueFrt11.h \
    ../XlsFormat/Logic/Biff_records/ContinueFrt12.h \
    ../XlsFormat/Logic/Biff_records/Country.h \
    ../XlsFormat/Logic/Biff_records/CrErr.h \
    ../XlsFormat/Logic/Biff_records/CRN.h \
    ../XlsFormat/Logic/Biff_records/CrtLayout12.h \
    ../XlsFormat/Logic/Biff_records/CrtLayout12A.h \
    ../XlsFormat/Logic/Biff_records/CrtLine.h \
    ../XlsFormat/Logic/Biff_records/CrtLink.h \
    ../XlsFormat/Logic/Biff_records/CrtMlFrt.h \
    ../XlsFormat/Logic/Biff_records/CrtMlFrtContinue.h \
    ../XlsFormat/Logic/Biff_records/Dat.h \
    ../XlsFormat/Logic/Biff_records/DataFormat.h \
    ../XlsFormat/Logic/Biff_records/DataLabExt.h \
    ../XlsFormat/Logic/Biff_records/DataLabExtContents.h \
    ../XlsFormat/Logic/Biff_records/Date1904.h \
    ../XlsFormat/Logic/Biff_records/DBCell.h \
    ../XlsFormat/Logic/Biff_records/DbOrParamQry.h \
    ../XlsFormat/Logic/Biff_records/DBQueryExt.h \
    ../XlsFormat/Logic/Biff_records/DCon.h \
    ../XlsFormat/Logic/Biff_records/DConBin.h \
    ../XlsFormat/Logic/Biff_records/DConn.h \
    ../XlsFormat/Logic/Biff_records/DConName.h \
    ../XlsFormat/Logic/Biff_records/DConRef.h \
    ../XlsFormat/Logic/Biff_records/DefaultRowHeight.h \
    ../XlsFormat/Logic/Biff_records/DefaultText.h \
    ../XlsFormat/Logic/Biff_records/DefColWidth.h \
    ../XlsFormat/Logic/Biff_records/Dimensions.h \
    ../XlsFormat/Logic/Biff_records/DocRoute.h \
    ../XlsFormat/Logic/Biff_records/DropBar.h \
    ../XlsFormat/Logic/Biff_records/DropDownObjIds.h \
    ../XlsFormat/Logic/Biff_records/DSF.h \
    ../XlsFormat/Logic/Biff_records/Dv.h \
    ../XlsFormat/Logic/Biff_records/DVal.h \
    ../XlsFormat/Logic/Biff_records/DXF.h \
    ../XlsFormat/Logic/Biff_records/DxGCol.h \
    ../XlsFormat/Logic/Biff_records/End.h \
    ../XlsFormat/Logic/Biff_records/EndObject.h \
    ../XlsFormat/Logic/Biff_records/EntExU2.h \
    ../XlsFormat/Logic/Biff_records/EOF.h \
    ../XlsFormat/Logic/Biff_records/Excel9File.h \
    ../XlsFormat/Logic/Biff_records/ExternName.h \
    ../XlsFormat/Logic/Biff_records/ExternSheet.h \
    ../XlsFormat/Logic/Biff_records/ExtSST.h \
    ../XlsFormat/Logic/Biff_records/ExtString.h \
    ../XlsFormat/Logic/Biff_records/Fbi.h \
    ../XlsFormat/Logic/Biff_records/Fbi2.h \
    ../XlsFormat/Logic/Biff_records/Feat.h \
    ../XlsFormat/Logic/Biff_records/FeatHdr.h \
    ../XlsFormat/Logic/Biff_records/FeatHdr11.h \
    ../XlsFormat/Logic/Biff_records/Feature11.h \
    ../XlsFormat/Logic/Biff_records/Feature12.h \
    ../XlsFormat/Logic/Biff_records/FilePass.h \
    ../XlsFormat/Logic/Biff_records/FileSharing.h \
    ../XlsFormat/Logic/Biff_records/FilterMode.h \
    ../XlsFormat/Logic/Biff_records/FnGroupName.h \
    ../XlsFormat/Logic/Biff_records/FnGrp12.h \
    ../XlsFormat/Logic/Biff_records/Font.h \
    ../XlsFormat/Logic/Biff_records/FontX.h \
    ../XlsFormat/Logic/Biff_records/Footer.h \
    ../XlsFormat/Logic/Biff_records/ForceFullCalculation.h \
    ../XlsFormat/Logic/Biff_records/Format.h \
    ../XlsFormat/Logic/Biff_records/Formula.h \
    ../XlsFormat/Logic/Biff_records/Frame.h \
    ../XlsFormat/Logic/Biff_records/FrtFontList.h \
    ../XlsFormat/Logic/Biff_records/GelFrame.h \
    ../XlsFormat/Logic/Biff_records/GridSet.h \
    ../XlsFormat/Logic/Biff_records/GUIDTypeLib.h \
    ../XlsFormat/Logic/Biff_records/Guts.h \
    ../XlsFormat/Logic/Biff_records/HCenter.h \
    ../XlsFormat/Logic/Biff_records/Header.h \
    ../XlsFormat/Logic/Biff_records/HeaderFooter.h \
    ../XlsFormat/Logic/Biff_records/HFPicture.h \
    ../XlsFormat/Logic/Biff_records/HideObj.h \
    ../XlsFormat/Logic/Biff_records/HLink.h \
    ../XlsFormat/Logic/Biff_records/HLinkTooltip.h \
    ../XlsFormat/Logic/Biff_records/HorizontalPageBreaks.h \
    ../XlsFormat/Logic/Biff_records/IFmtRecord.h \
    ../XlsFormat/Logic/Biff_records/Index.h \
    ../XlsFormat/Logic/Biff_records/InterfaceEnd.h \
    ../XlsFormat/Logic/Biff_records/InterfaceHdr.h \
    ../XlsFormat/Logic/Biff_records/Intl.h \
    ../XlsFormat/Logic/Biff_records/Label.h \
    ../XlsFormat/Logic/Biff_records/LabelSst.h \
    ../XlsFormat/Logic/Biff_records/Lbl.h \
    ../XlsFormat/Logic/Biff_records/LeftMargin.h \
    ../XlsFormat/Logic/Biff_records/Legend.h \
    ../XlsFormat/Logic/Biff_records/LegendException.h \
    ../XlsFormat/Logic/Biff_records/Lel.h \
    ../XlsFormat/Logic/Biff_records/Line.h \
    ../XlsFormat/Logic/Biff_records/LineFormat.h \
    ../XlsFormat/Logic/Biff_records/List12.h \
    ../XlsFormat/Logic/Biff_records/LPr.h \
    ../XlsFormat/Logic/Biff_records/LRng.h \
    ../XlsFormat/Logic/Biff_records/MarkerFormat.h \
    ../XlsFormat/Logic/Biff_records/MDB.h \
    ../XlsFormat/Logic/Biff_records/MDTInfo.h \
    ../XlsFormat/Logic/Biff_records/MDXKPI.h \
    ../XlsFormat/Logic/Biff_records/MDXProp.h \
    ../XlsFormat/Logic/Biff_records/MDXSet.h \
    ../XlsFormat/Logic/Biff_records/MDXStr.h \
    ../XlsFormat/Logic/Biff_records/MDXTuple.h \
    ../XlsFormat/Logic/Biff_records/MergeCells.h \
    ../XlsFormat/Logic/Biff_records/Mms.h \
    ../XlsFormat/Logic/Biff_records/MsoDrawing.h \
    ../XlsFormat/Logic/Biff_records/MsoDrawingGroup.h \
    ../XlsFormat/Logic/Biff_records/MsoDrawingSelection.h \
    ../XlsFormat/Logic/Biff_records/MTRSettings.h \
    ../XlsFormat/Logic/Biff_records/MulBlank.h \
    ../XlsFormat/Logic/Biff_records/MulRk.h \
    ../XlsFormat/Logic/Biff_records/NameCmt.h \
    ../XlsFormat/Logic/Biff_records/NameFnGrp12.h \
    ../XlsFormat/Logic/Biff_records/NamePublish.h \
    ../XlsFormat/Logic/Biff_records/Note.h \
    ../XlsFormat/Logic/Biff_records/Number.h \
    ../XlsFormat/Logic/Biff_records/Obj.h \
    ../XlsFormat/Logic/Biff_records/ObjectLink.h \
    ../XlsFormat/Logic/Biff_records/ObjProtect.h \
    ../XlsFormat/Logic/Biff_records/ObNoMacros.h \
    ../XlsFormat/Logic/Biff_records/ObProj.h \
    ../XlsFormat/Logic/Biff_records/OleDbConn.h \
    ../XlsFormat/Logic/Biff_records/OleObjectSize.h \
    ../XlsFormat/Logic/Biff_records/Palette.h \
    ../XlsFormat/Logic/Biff_records/Pane.h \
    ../XlsFormat/Logic/Biff_records/Password.h \
    ../XlsFormat/Logic/Biff_records/PhoneticInfo.h \
    ../XlsFormat/Logic/Biff_records/PicF.h \
    ../XlsFormat/Logic/Biff_records/Pie.h \
    ../XlsFormat/Logic/Biff_records/PieFormat.h \
    ../XlsFormat/Logic/Biff_records/PivotChartBits.h \
    ../XlsFormat/Logic/Biff_records/PlotArea.h \
    ../XlsFormat/Logic/Biff_records/PlotGrowth.h \
    ../XlsFormat/Logic/Biff_records/Pls.h \
    ../XlsFormat/Logic/Biff_records/PLV.h \
    ../XlsFormat/Logic/Biff_records/Pos.h \
    ../XlsFormat/Logic/Biff_records/PrintGrid.h \
    ../XlsFormat/Logic/Biff_records/PrintRowCol.h \
    ../XlsFormat/Logic/Biff_records/PrintSize.h \
    ../XlsFormat/Logic/Biff_records/Prot4Rev.h \
    ../XlsFormat/Logic/Biff_records/Prot4RevPass.h \
    ../XlsFormat/Logic/Biff_records/Protect.h \
    ../XlsFormat/Logic/Biff_records/Qsi.h \
    ../XlsFormat/Logic/Biff_records/Qsif.h \
    ../XlsFormat/Logic/Biff_records/Qsir.h \
    ../XlsFormat/Logic/Biff_records/QsiSXTag.h \
    ../XlsFormat/Logic/Biff_records/Radar.h \
    ../XlsFormat/Logic/Biff_records/RadarArea.h \
    ../XlsFormat/Logic/Biff_records/RealTimeData.h \
    ../XlsFormat/Logic/Biff_records/RecalcId.h \
    ../XlsFormat/Logic/Biff_records/RecipName.h \
    ../XlsFormat/Logic/Biff_records/RefreshAll.h \
    ../XlsFormat/Logic/Biff_records/RichTextStream.h \
    ../XlsFormat/Logic/Biff_records/RightMargin.h \
    ../XlsFormat/Logic/Biff_records/RK.h \
    ../XlsFormat/Logic/Biff_records/Row.h \
    ../XlsFormat/Logic/Biff_records/RRSort.h \
    ../XlsFormat/Logic/Biff_records/RRTabId.h \
    ../XlsFormat/Logic/Biff_records/SBaseRef.h \
    ../XlsFormat/Logic/Biff_records/Scatter.h \
    ../XlsFormat/Logic/Biff_records/SCENARIO.h \
    ../XlsFormat/Logic/Biff_records/ScenarioProtect.h \
    ../XlsFormat/Logic/Biff_records/ScenMan.h \
    ../XlsFormat/Logic/Biff_records/Scl.h \
    ../XlsFormat/Logic/Biff_records/Selection.h \
    ../XlsFormat/Logic/Biff_records/SerAuxErrBar.h \
    ../XlsFormat/Logic/Biff_records/SerAuxTrend.h \
    ../XlsFormat/Logic/Biff_records/SerFmt.h \
    ../XlsFormat/Logic/Biff_records/Series.h \
    ../XlsFormat/Logic/Biff_records/SeriesList.h \
    ../XlsFormat/Logic/Biff_records/SeriesText.h \
    ../XlsFormat/Logic/Biff_records/SerParent.h \
    ../XlsFormat/Logic/Biff_records/SerToCrt.h \
    ../XlsFormat/Logic/Biff_records/Setup.h \
    ../XlsFormat/Logic/Biff_records/ShapePropsStream.h \
    ../XlsFormat/Logic/Biff_records/SheetExt.h \
    ../XlsFormat/Logic/Biff_records/ShrFmla.h \
    ../XlsFormat/Logic/Biff_records/ShtProps.h \
    ../XlsFormat/Logic/Biff_records/SIIndex.h \
    ../XlsFormat/Logic/Biff_records/Sort.h \
    ../XlsFormat/Logic/Biff_records/SortData.h \
    ../XlsFormat/Logic/Biff_records/SST.h \
    ../XlsFormat/Logic/Biff_records/StartObject.h \
    ../XlsFormat/Logic/Biff_records/String.h \
    ../XlsFormat/Logic/Biff_records/Style.h \
    ../XlsFormat/Logic/Biff_records/StyleExt.h \
    ../XlsFormat/Logic/Biff_records/SupBook.h \
    ../XlsFormat/Logic/Biff_records/Surf.h \
    ../XlsFormat/Logic/Biff_records/SXAddl.h \
    ../XlsFormat/Logic/Biff_records/SXDI.h \
    ../XlsFormat/Logic/Biff_records/SxDXF.h \
    ../XlsFormat/Logic/Biff_records/SXEx.h \
    ../XlsFormat/Logic/Biff_records/SxFilt.h \
    ../XlsFormat/Logic/Biff_records/SxFormat.h \
    ../XlsFormat/Logic/Biff_records/SxItm.h \
    ../XlsFormat/Logic/Biff_records/SxIvd.h \
    ../XlsFormat/Logic/Biff_records/SXLI.h \
    ../XlsFormat/Logic/Biff_records/SXPI.h \
    ../XlsFormat/Logic/Biff_records/SXPIEx.h \
    ../XlsFormat/Logic/Biff_records/SxRule.h \
    ../XlsFormat/Logic/Biff_records/SxSelect.h \
    ../XlsFormat/Logic/Biff_records/SXStreamID.h \
    ../XlsFormat/Logic/Biff_records/SXString.h \
    ../XlsFormat/Logic/Biff_records/SXTbl.h \
    ../XlsFormat/Logic/Biff_records/SxTbpg.h \
    ../XlsFormat/Logic/Biff_records/SXTBRGIITM.h \
    ../XlsFormat/Logic/Biff_records/SXTH.h \
    ../XlsFormat/Logic/Biff_records/Sxvd.h \
    ../XlsFormat/Logic/Biff_records/SXVDEx.h \
    ../XlsFormat/Logic/Biff_records/SXVDTEx.h \
    ../XlsFormat/Logic/Biff_records/SXVI.h \
    ../XlsFormat/Logic/Biff_records/SxView.h \
    ../XlsFormat/Logic/Biff_records/SXViewEx.h \
    ../XlsFormat/Logic/Biff_records/SXViewEx9.h \
    ../XlsFormat/Logic/Biff_records/SXViewLink.h \
    ../XlsFormat/Logic/Biff_records/SXVS.h \
    ../XlsFormat/Logic/Biff_records/Sync.h \
    ../XlsFormat/Logic/Biff_records/Table.h \
    ../XlsFormat/Logic/Biff_records/TableStyle.h \
    ../XlsFormat/Logic/Biff_records/TableStyleElement.h \
    ../XlsFormat/Logic/Biff_records/TableStyles.h \
    ../XlsFormat/Logic/Biff_records/Template.h \
    ../XlsFormat/Logic/Biff_records/Text.h \
    ../XlsFormat/Logic/Biff_records/TextPropsStream.h \
    ../XlsFormat/Logic/Biff_records/Theme.h \
    ../XlsFormat/Logic/Biff_records/Tick.h \
    ../XlsFormat/Logic/Biff_records/TopMargin.h \
    ../XlsFormat/Logic/Biff_records/TxO.h \
    ../XlsFormat/Logic/Biff_records/TxtQry.h \
    ../XlsFormat/Logic/Biff_records/Uncalced.h \
    ../XlsFormat/Logic/Biff_records/Units.h \
    ../XlsFormat/Logic/Biff_records/UserBView.h \
    ../XlsFormat/Logic/Biff_records/UserSViewBegin.h \
    ../XlsFormat/Logic/Biff_records/UserSViewEnd.h \
    ../XlsFormat/Logic/Biff_records/UsesELFs.h \
    ../XlsFormat/Logic/Biff_records/ValueRange.h \
    ../XlsFormat/Logic/Biff_records/VCenter.h \
    ../XlsFormat/Logic/Biff_records/VerticalPageBreaks.h \
    ../XlsFormat/Logic/Biff_records/WebPub.h \
    ../XlsFormat/Logic/Biff_records/Window1.h \
    ../XlsFormat/Logic/Biff_records/Window2.h \
    ../XlsFormat/Logic/Biff_records/WinProtect.h \
    ../XlsFormat/Logic/Biff_records/WOpt.h \
    ../XlsFormat/Logic/Biff_records/WriteAccess.h \
    ../XlsFormat/Logic/Biff_records/WriteProtect.h \
    ../XlsFormat/Logic/Biff_records/WsBool.h \
    ../XlsFormat/Logic/Biff_records/XCT.h \
    ../XlsFormat/Logic/Biff_records/XF.h \
    ../XlsFormat/Logic/Biff_records/XFCRC.h \
    ../XlsFormat/Logic/Biff_records/XFExt.h \
    ../XlsFormat/Logic/Biff_records/YMult.h \
    ../XlsFormat/Binary/BinSmartPointers.h \
    ../XlsFormat/Binary/CFRecord.h \
    ../XlsFormat/Binary/CFRecordType.h \
    ../XlsFormat/Binary/CFStream.h \
    ../XlsFormat/Binary/CFStreamCacheReader.h \
    ../XlsFormat/Binary/CFStreamCacheWriter.h \
    ../XlsFormat/Binary/CompoundFile.h \
    ../XlsFormat/Crypt/rtl/cipher.h \
    ../XlsFormat/Crypt/rtl/digest.h \
    ../XlsFormat/Crypt/BiffDecoder_RCF.h \
    ../XlsFormat/Crypt/BinaryCodec_RCF.h \
    ../XlsFormat/Crypt/Crypt.h \
    ../XlsFormat/Crypt/Decryptor.h \
    ../XlsFormat/Crypt/RC4Crypt.h \
    ../XlsFormat/Logging/Log.h \
    ../XlsFormat/Logging/Logger.h \
    ../XlsFormat/Logic/Biff_structures/AddinUdf.h \
    ../XlsFormat/Logic/Biff_structures/AF12Criteria.h \
    ../XlsFormat/Logic/Biff_structures/AFDOper.h \
    ../XlsFormat/Logic/Biff_structures/AFDOperRk.h \
    ../XlsFormat/Logic/Biff_structures/AFDOperStr.h \
    ../XlsFormat/Logic/Biff_structures/AntiMoniker.h \
    ../XlsFormat/Logic/Biff_structures/ArrayParsedFormula.h \
    ../XlsFormat/Logic/Biff_structures/Bes.h \
    ../XlsFormat/Logic/Biff_structures/BiffAttribute.h \
    ../XlsFormat/Logic/Biff_structures/BiffString.h \
    ../XlsFormat/Logic/Biff_structures/BiffStructure.h \
    ../XlsFormat/Logic/Biff_structures/BitMarkedStructs.h \
    ../XlsFormat/Logic/Biff_structures/BookExt_Conditional11.h \
    ../XlsFormat/Logic/Biff_structures/BookExt_Conditional12.h \
    ../XlsFormat/Logic/Biff_structures/Boolean.h \
    ../XlsFormat/Logic/Biff_structures/BorderFillInfo.h \
    ../XlsFormat/Logic/Biff_structures/BuiltInStyle.h \
    ../XlsFormat/Logic/Biff_structures/Cell.h \
    ../XlsFormat/Logic/Biff_structures/CellOffsetResender.h \
    ../XlsFormat/Logic/Biff_structures/CellParsedFormula.h \
    ../XlsFormat/Logic/Biff_structures/CellRangeRef.h \
    ../XlsFormat/Logic/Biff_structures/CellRef.h \
    ../XlsFormat/Logic/Biff_structures/CellXF.h \
    ../XlsFormat/Logic/Biff_structures/Cetab.h \
    ../XlsFormat/Logic/Biff_structures/CFColor.h \
    ../XlsFormat/Logic/Biff_structures/CFExNonCF12.h \
    ../XlsFormat/Logic/Biff_structures/CFExTemplateParams.h \
    ../XlsFormat/Logic/Biff_structures/CFMStateItem.h \
    ../XlsFormat/Logic/Biff_structures/CFMultistate.h \
    ../XlsFormat/Logic/Biff_structures/CFParsedFormula.h \
    ../XlsFormat/Logic/Biff_structures/CFParsedFormulaNoCCE.h \
    ../XlsFormat/Logic/Biff_structures/CFVO.h \
    ../XlsFormat/Logic/Biff_structures/CFVOParsedFormula.h \
    ../XlsFormat/Logic/Biff_structures/ChartNumNillable.h \
    ../XlsFormat/Logic/Biff_structures/ChartParsedFormula.h \
    ../XlsFormat/Logic/Biff_structures/CompositeMoniker.h \
    ../XlsFormat/Logic/Biff_structures/CondFmtStructure.h \
    ../XlsFormat/Logic/Biff_structures/ControlInfo.h \
    ../XlsFormat/Logic/Biff_structures/DropDownObjId.h \
    ../XlsFormat/Logic/Biff_structures/DVParsedFormula.h \
    ../XlsFormat/Logic/Biff_structures/DXFALC.h \
    ../XlsFormat/Logic/Biff_structures/DXFBdr.h \
    ../XlsFormat/Logic/Biff_structures/DXFFntD.h \
    ../XlsFormat/Logic/Biff_structures/DXFId.h \
    ../XlsFormat/Logic/Biff_structures/DXFN.h \
    ../XlsFormat/Logic/Biff_structures/DXFN12.h \
    ../XlsFormat/Logic/Biff_structures/DXFN12List.h \
    ../XlsFormat/Logic/Biff_structures/DXFNum.h \
    ../XlsFormat/Logic/Biff_structures/DXFNumUsr.h \
    ../XlsFormat/Logic/Biff_structures/DXFPat.h \
    ../XlsFormat/Logic/Biff_structures/DXFProt.h \
    ../XlsFormat/Logic/Biff_structures/EncryptionHeader.h \
    ../XlsFormat/Logic/Biff_structures/EncryptionHeaderFlags.h \
    ../XlsFormat/Logic/Biff_structures/EncryptionVerifier.h \
    ../XlsFormat/Logic/Biff_structures/EnhancedProtection.h \
    ../XlsFormat/Logic/Biff_structures/ExternDdeLinkNoOper.h \
    ../XlsFormat/Logic/Biff_structures/ExternDocName.h \
    ../XlsFormat/Logic/Biff_structures/ExternOleDdeLink.h \
    ../XlsFormat/Logic/Biff_structures/ExtNameParsedFormula.h \
    ../XlsFormat/Logic/Biff_structures/ExtProp.h \
    ../XlsFormat/Logic/Biff_structures/ExtPtgArea3D.h \
    ../XlsFormat/Logic/Biff_structures/ExtPtgAreaErr3D.h \
    ../XlsFormat/Logic/Biff_structures/ExtPtgErr.h \
    ../XlsFormat/Logic/Biff_structures/ExtPtgRef3D.h \
    ../XlsFormat/Logic/Biff_structures/ExtPtgRefErr3D.h \
    ../XlsFormat/Logic/Biff_structures/ExtRst.h \
    ../XlsFormat/Logic/Biff_structures/FactoidData.h \
    ../XlsFormat/Logic/Biff_structures/FactoidType.h \
    ../XlsFormat/Logic/Biff_structures/Feat11FdaAutoFilter.h \
    ../XlsFormat/Logic/Biff_structures/Feat11FieldDataItem.h \
    ../XlsFormat/Logic/Biff_structures/FeatFormulaErr2.h \
    ../XlsFormat/Logic/Biff_structures/FeatProtection.h \
    ../XlsFormat/Logic/Biff_structures/FeatSmartTag.h \
    ../XlsFormat/Logic/Biff_structures/FileMoniker.h \
    ../XlsFormat/Logic/Biff_structures/FileOffset.h \
    ../XlsFormat/Logic/Biff_structures/FilePointer.h \
    ../XlsFormat/Logic/Biff_structures/FixedPoint.h \
    ../XlsFormat/Logic/Biff_structures/FontIndex.h \
    ../XlsFormat/Logic/Biff_structures/FormatRun.h \
    ../XlsFormat/Logic/Biff_structures/FormulaValue.h \
    ../XlsFormat/Logic/Biff_structures/FrtHeader.h \
    ../XlsFormat/Logic/Biff_structures/FrtHeaderOld.h \
    ../XlsFormat/Logic/Biff_structures/FrtRefHeader.h \
    ../XlsFormat/Logic/Biff_structures/FrtRefHeaderNoGrbit.h \
    ../XlsFormat/Logic/Biff_structures/FrtRefHeaderU.h \
    ../XlsFormat/Logic/Biff_structures/Ftab_Cetab.h \
    ../XlsFormat/Logic/Biff_structures/FtCblsData.h \
    ../XlsFormat/Logic/Biff_structures/FtCf.h \
    ../XlsFormat/Logic/Biff_structures/FtCmo.h \
    ../XlsFormat/Logic/Biff_structures/FtEdoData.h \
    ../XlsFormat/Logic/Biff_structures/FtGboData.h \
    ../XlsFormat/Logic/Biff_structures/FtLbsData.h \
    ../XlsFormat/Logic/Biff_structures/FtMacro.h \
    ../XlsFormat/Logic/Biff_structures/FtNts.h \
    ../XlsFormat/Logic/Biff_structures/FtPictFmla.h \
    ../XlsFormat/Logic/Biff_structures/FtPioGrbit.h \
    ../XlsFormat/Logic/Biff_structures/FtRboData.h \
    ../XlsFormat/Logic/Biff_structures/FtSbs.h \
    ../XlsFormat/Logic/Biff_structures/FullColorExt.h \
    ../XlsFormat/Logic/Biff_structures/GradStop.h \
    ../XlsFormat/Logic/Biff_structures/HideObjEnum.h \
    ../XlsFormat/Logic/Biff_structures/HorzBrk.h \
    ../XlsFormat/Logic/Biff_structures/HyperlinkMoniker.h \
    ../XlsFormat/Logic/Biff_structures/HyperlinkObject.h \
    ../XlsFormat/Logic/Biff_structures/ISSTInf.h \
    ../XlsFormat/Logic/Biff_structures/ItemMoniker.h \
    ../XlsFormat/Logic/Biff_structures/LbsDropData.h \
    ../XlsFormat/Logic/Biff_structures/List12BlockLevel.h \
    ../XlsFormat/Logic/Biff_structures/List12DisplayName.h \
    ../XlsFormat/Logic/Biff_structures/List12TableStyleClientInfo.h \
    ../XlsFormat/Logic/Biff_structures/LongRGB.h \
    ../XlsFormat/Logic/Biff_structures/MDir.h \
    ../XlsFormat/Logic/Biff_structures/MDXStrIndex.h \
    ../XlsFormat/Logic/Biff_structures/MOper.h \
    ../XlsFormat/Logic/Biff_structures/NameParsedFormula.h \
    ../XlsFormat/Logic/Biff_structures/NoteRR.h \
    ../XlsFormat/Logic/Biff_structures/NoteSh.h \
    ../XlsFormat/Logic/Biff_structures/ObjectParsedFormula.h \
    ../XlsFormat/Logic/Biff_structures/ObjFmla.h \
    ../XlsFormat/Logic/Biff_structures/ObjLinkFmla.h \
    ../XlsFormat/Logic/Biff_structures/OperandPtg.h \
    ../XlsFormat/Logic/Biff_structures/OperatorPtgs.h \
    ../XlsFormat/Logic/Biff_structures/PaneType.h \
    ../XlsFormat/Logic/Biff_structures/ParsedFormula.h \
    ../XlsFormat/Logic/Biff_structures/PhRuns.h \
    ../XlsFormat/Logic/Biff_structures/Phs.h \
    ../XlsFormat/Logic/Biff_structures/PictFmlaEmbedInfo.h \
    ../XlsFormat/Logic/Biff_structures/PictFmlaKey.h \
    ../XlsFormat/Logic/Biff_structures/PropertyBag.h \
    ../XlsFormat/Logic/Biff_structures/PropertyBagStore.h \
    ../XlsFormat/Logic/Biff_structures/Ptg.h \
    ../XlsFormat/Logic/Biff_structures/PtgArea.h \
    ../XlsFormat/Logic/Biff_structures/PtgArea3d.h \
    ../XlsFormat/Logic/Biff_structures/PtgAreaErr.h \
    ../XlsFormat/Logic/Biff_structures/PtgAreaErr3d.h \
    ../XlsFormat/Logic/Biff_structures/PtgAreaN.h \
    ../XlsFormat/Logic/Biff_structures/PtgArray.h \
    ../XlsFormat/Logic/Biff_structures/PtgAttrBaxcel.h \
    ../XlsFormat/Logic/Biff_structures/PtgAttrChoose.h \
    ../XlsFormat/Logic/Biff_structures/PtgAttrGoto.h \
    ../XlsFormat/Logic/Biff_structures/PtgAttrIf.h \
    ../XlsFormat/Logic/Biff_structures/PtgAttrSemi.h \
    ../XlsFormat/Logic/Biff_structures/PtgAttrSpace.h \
    ../XlsFormat/Logic/Biff_structures/PtgAttrSpaceSemi.h \
    ../XlsFormat/Logic/Biff_structures/PtgAttrSum.h \
    ../XlsFormat/Logic/Biff_structures/PtgBool.h \
    ../XlsFormat/Logic/Biff_structures/PtgElfCol.h \
    ../XlsFormat/Logic/Biff_structures/PtgElfColS.h \
    ../XlsFormat/Logic/Biff_structures/PtgElfColSV.h \
    ../XlsFormat/Logic/Biff_structures/PtgElfColV.h \
    ../XlsFormat/Logic/Biff_structures/PtgElfLel.h \
    ../XlsFormat/Logic/Biff_structures/PtgElfRadical.h \
    ../XlsFormat/Logic/Biff_structures/PtgElfRadicalLel.h \
    ../XlsFormat/Logic/Biff_structures/PtgElfRadicalS.h \
    ../XlsFormat/Logic/Biff_structures/PtgElfRw.h \
    ../XlsFormat/Logic/Biff_structures/PtgElfRwV.h \
    ../XlsFormat/Logic/Biff_structures/PtgErr.h \
    ../XlsFormat/Logic/Biff_structures/PtgExp.h \
    ../XlsFormat/Logic/Biff_structures/PtgExtraArray.h \
    ../XlsFormat/Logic/Biff_structures/PtgExtraElf.h \
    ../XlsFormat/Logic/Biff_structures/PtgExtraMem.h \
    ../XlsFormat/Logic/Biff_structures/PtgFactory.h \
    ../XlsFormat/Logic/Biff_structures/PtgFunc.h \
    ../XlsFormat/Logic/Biff_structures/PtgFuncVar.h \
    ../XlsFormat/Logic/Biff_structures/PtgInt.h \
    ../XlsFormat/Logic/Biff_structures/PtgMemArea.h \
    ../XlsFormat/Logic/Biff_structures/PtgMemAreaN.h \
    ../XlsFormat/Logic/Biff_structures/PtgMemErr.h \
    ../XlsFormat/Logic/Biff_structures/PtgMemFunc.h \
    ../XlsFormat/Logic/Biff_structures/PtgMemNoMem.h \
    ../XlsFormat/Logic/Biff_structures/PtgMemNoMemN.h \
    ../XlsFormat/Logic/Biff_structures/PtgMissArg.h \
    ../XlsFormat/Logic/Biff_structures/PtgName.h \
    ../XlsFormat/Logic/Biff_structures/PtgNameX.h \
    ../XlsFormat/Logic/Biff_structures/PtgNum.h \
    ../XlsFormat/Logic/Biff_structures/PtgParam.h \
    ../XlsFormat/Logic/Biff_structures/PtgParen.h \
    ../XlsFormat/Logic/Biff_structures/PtgRef.h \
    ../XlsFormat/Logic/Biff_structures/PtgRef3d.h \
    ../XlsFormat/Logic/Biff_structures/PtgRefErr.h \
    ../XlsFormat/Logic/Biff_structures/PtgRefErr3d.h \
    ../XlsFormat/Logic/Biff_structures/PtgRefN.h \
    ../XlsFormat/Logic/Biff_structures/PtgStr.h \
    ../XlsFormat/Logic/Biff_structures/PtgSxName.h \
    ../XlsFormat/Logic/Biff_structures/PtgTbl.h \
    ../XlsFormat/Logic/Biff_structures/RC4CryptoAPIEncryptionHeader.h \
    ../XlsFormat/Logic/Biff_structures/RC4EncryptionHeader.h \
    ../XlsFormat/Logic/Biff_structures/RevExtern.h \
    ../XlsFormat/Logic/Biff_structures/RevItab.h \
    ../XlsFormat/Logic/Biff_structures/RevLblName.h \
    ../XlsFormat/Logic/Biff_structures/RevName.h \
    ../XlsFormat/Logic/Biff_structures/RevNamePly.h \
    ../XlsFormat/Logic/Biff_structures/RevNameTabid.h \
    ../XlsFormat/Logic/Biff_structures/RgbExtra.h \
    ../XlsFormat/Logic/Biff_structures/Rgce.h \
    ../XlsFormat/Logic/Biff_structures/RkRec.h \
    ../XlsFormat/Logic/Biff_structures/RPHSSub.h \
    ../XlsFormat/Logic/Biff_structures/RRD.h \
    ../XlsFormat/Logic/Biff_structures/Run.h \
    ../XlsFormat/Logic/Biff_structures/SDContainer.h \
    ../XlsFormat/Logic/Biff_structures/SecurityDescriptor.h \
    ../XlsFormat/Logic/Biff_structures/SerAr.h \
    ../XlsFormat/Logic/Biff_structures/SerBool.h \
    ../XlsFormat/Logic/Biff_structures/SerErr.h \
    ../XlsFormat/Logic/Biff_structures/SerNil.h \
    ../XlsFormat/Logic/Biff_structures/SerNum.h \
    ../XlsFormat/Logic/Biff_structures/SerStr.h \
    ../XlsFormat/Logic/Biff_structures/SharedParsedFormula.h \
    ../XlsFormat/Logic/Biff_structures/SheetExtOptional.h \
    ../XlsFormat/Logic/Biff_structures/SheetId.h \
    ../XlsFormat/Logic/Biff_structures/SortCond12.h \
    ../XlsFormat/Logic/Biff_structures/SqRef.h \
    ../XlsFormat/Logic/Biff_structures/SqRefU.h \
    ../XlsFormat/Logic/Biff_structures/StringPtgParser.h \
    ../XlsFormat/Logic/Biff_structures/Stxp.h \
    ../XlsFormat/Logic/Biff_structures/StyleXF.h \
    ../XlsFormat/Logic/Biff_structures/SyntaxPtg.h \
    ../XlsFormat/Logic/Biff_structures/TableFeatureType.h \
    ../XlsFormat/Logic/Biff_structures/TxOLastRun.h \
    ../XlsFormat/Logic/Biff_structures/TxORuns.h \
    ../XlsFormat/Logic/Biff_structures/URICreateFlags.h \
    ../XlsFormat/Logic/Biff_structures/URLMoniker.h \
    ../XlsFormat/Logic/Biff_structures/VertBrk.h \
    ../XlsFormat/Logic/Biff_structures/XFExtGradient.h \
    ../XlsFormat/Logic/Biff_structures/XFExtNoFRT.h \
    ../XlsFormat/Logic/Biff_structures/XFProp.h \
    ../XlsFormat/Logic/Biff_structures/XFPropBorder.h \
    ../XlsFormat/Logic/Biff_structures/XFPropColor.h \
    ../XlsFormat/Logic/Biff_structures/XFPropGradient.h \
    ../XlsFormat/Logic/Biff_structures/XFPropGradientStop.h \
    ../XlsFormat/Logic/Biff_structures/XFProps.h \
    ../XlsFormat/Logic/Biff_structures/XLUnicodeRichExtendedString.h \
    ../XlsFormat/Logic/Biff_structures/XORObfuscation.h \
    ../XlsFormat/Logic/Biff_structures/XTI.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/IMsoArray.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/MSOCR.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/MSO_enums.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/MSOSHADECOLOR.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtBlip.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtBStoreContainer.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtBStoreContainerFileBlock.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtClientAnchorChart.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtClientAnchorHF.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtClientAnchorSheet.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtColorMRUContainer.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtCOLORREF.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtContainer.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtDgContainer.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtFDG.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtFDGGBlock.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtFOPT.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtFOPTE.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtFRIT.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtFRITContainer.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtFSP.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtFSPGR.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtIDCL.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtMetafileHeader.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtRecord.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtRecordHeader.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtRGFOPTE.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtSplitMenuColorContainer.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/OfficeArtTertiaryFOPT.h \
    ../XlsFormat/Logic/Biff_structures/ODRAW/SimpleOfficeArtContainers.h \
    ../XlsFormat/Logic/Biff_unions/AI.h \
    ../XlsFormat/Logic/Biff_unions/ATTACHEDLABEL.h \
    ../XlsFormat/Logic/Biff_unions/AUTOFILTER.h \
    ../XlsFormat/Logic/Biff_unions/AXES.h \
    ../XlsFormat/Logic/Biff_unions/AXISPARENT.h \
    ../XlsFormat/Logic/Biff_unions/AXM.h \
    ../XlsFormat/Logic/Biff_unions/AXS.h \
    ../XlsFormat/Logic/Biff_unions/BACKGROUND.h \
    ../XlsFormat/Logic/Biff_unions/BIGNAME.h \
    ../XlsFormat/Logic/Biff_unions/BUNDLESHEET.h \
    ../XlsFormat/Logic/Biff_unions/CELL.h \
    ../XlsFormat/Logic/Biff_unions/CELLTABLE.h \
    ../XlsFormat/Logic/Biff_unions/CHART.h \
    ../XlsFormat/Logic/Biff_unions/CHARTFOMATS.h \
    ../XlsFormat/Logic/Biff_unions/COLUMNS.h \
    ../XlsFormat/Logic/Biff_unions/CONDFMT.h \
    ../XlsFormat/Logic/Biff_unions/CONDFMT12.h \
    ../XlsFormat/Logic/Biff_unions/CONDFMTS.h \
    ../XlsFormat/Logic/Biff_unions/CRT.h \
    ../XlsFormat/Logic/Biff_unions/CRTMLFRT.h \
    ../XlsFormat/Logic/Biff_unions/CUSTOMVIEW.h \
    ../XlsFormat/Logic/Biff_unions/DAT.h \
    ../XlsFormat/Logic/Biff_unions/DBQUERY.h \
    ../XlsFormat/Logic/Biff_unions/DBQUERYEXT.h \
    ../XlsFormat/Logic/Biff_unions/DCON.h \
    ../XlsFormat/Logic/Biff_unions/DFTTEXT.h \
    ../XlsFormat/Logic/Biff_unions/DOCROUTE.h \
    ../XlsFormat/Logic/Biff_unions/DREF.h \
    ../XlsFormat/Logic/Biff_unions/DROPBAR.h \
    ../XlsFormat/Logic/Biff_unions/DVAL.h \
    ../XlsFormat/Logic/Biff_unions/DVAXIS.h \
    ../XlsFormat/Logic/Biff_unions/FEAT.h \
    ../XlsFormat/Logic/Biff_unions/FEAT11.h \
    ../XlsFormat/Logic/Biff_unions/FNGROUPS.h \
    ../XlsFormat/Logic/Biff_unions/FONTLIST.h \
    ../XlsFormat/Logic/Biff_unions/FORMATTING.h \
    ../XlsFormat/Logic/Biff_unions/FORMULA.h \
    ../XlsFormat/Logic/Biff_unions/FRAME.h \
    ../XlsFormat/Logic/Biff_unions/GELFRAME.h \
    ../XlsFormat/Logic/Biff_unions/GLOBALS.h \
    ../XlsFormat/Logic/Biff_unions/HLINK.h \
    ../XlsFormat/Logic/Biff_unions/INTERFACE.h \
    ../XlsFormat/Logic/Biff_unions/IVAXIS.h \
    ../XlsFormat/Logic/Biff_unions/LBL.h \
    ../XlsFormat/Logic/Biff_unions/LD.h \
    ../XlsFormat/Logic/Biff_unions/MACROSORTANDFILTER.h \
    ../XlsFormat/Logic/Biff_unions/MDBLOCK.h \
    ../XlsFormat/Logic/Biff_unions/MDTINFO.h \
    ../XlsFormat/Logic/Biff_unions/MDXSTR.h \
    ../XlsFormat/Logic/Biff_unions/MDXTUPLESET.h \
    ../XlsFormat/Logic/Biff_unions/METADATA.h \
    ../XlsFormat/Logic/Biff_unions/MSODRAWINGGROUP.h \
    ../XlsFormat/Logic/Biff_unions/OBJ.h \
    ../XlsFormat/Logic/Biff_unions/OBJECTS.h \
    ../XlsFormat/Logic/Biff_unions/PAGESETUP.h \
    ../XlsFormat/Logic/Biff_unions/PHONETICINFO.h \
    ../XlsFormat/Logic/Biff_unions/PICF.h \
    ../XlsFormat/Logic/Biff_unions/PIVOTADDL.h \
    ../XlsFormat/Logic/Biff_unions/PIVOTCACHEDEFINITION.h \
    ../XlsFormat/Logic/Biff_unions/PIVOTCORE.h \
    ../XlsFormat/Logic/Biff_unions/PIVOTEX.h \
    ../XlsFormat/Logic/Biff_unions/PIVOTFORMAT.h \
    ../XlsFormat/Logic/Biff_unions/PIVOTFRT.h \
    ../XlsFormat/Logic/Biff_unions/PIVOTFRT9.h \
    ../XlsFormat/Logic/Biff_unions/PIVOTIVD.h \
    ../XlsFormat/Logic/Biff_unions/PIVOTLI.h \
    ../XlsFormat/Logic/Biff_unions/PIVOTPI.h \
    ../XlsFormat/Logic/Biff_unions/PIVOTRULE.h \
    ../XlsFormat/Logic/Biff_unions/PIVOTSELECT.h \
    ../XlsFormat/Logic/Biff_unions/PIVOTTH.h \
    ../XlsFormat/Logic/Biff_unions/PIVOTVD.h \
    ../XlsFormat/Logic/Biff_unions/PIVOTVDTEX.h \
    ../XlsFormat/Logic/Biff_unions/PIVOTVIEW.h \
    ../XlsFormat/Logic/Biff_unions/PIVOTVIEWEX.h \
    ../XlsFormat/Logic/Biff_unions/PRFILTER.h \
    ../XlsFormat/Logic/Biff_unions/PROTECTION.h \
    ../XlsFormat/Logic/Biff_unions/PROTECTION_COMMON.h \
    ../XlsFormat/Logic/Biff_unions/QSIR.h \
    ../XlsFormat/Logic/Biff_unions/QUERYTABLE.h \
    ../XlsFormat/Logic/Biff_unions/RECORD12.h \
    ../XlsFormat/Logic/Biff_unions/RTD.h \
    ../XlsFormat/Logic/Biff_unions/SCENARIOS.h \
    ../XlsFormat/Logic/Biff_unions/SERIESAXIS.h \
    ../XlsFormat/Logic/Biff_unions/SERIESDATA.h \
    ../XlsFormat/Logic/Biff_unions/SERIESFORMAT.h \
    ../XlsFormat/Logic/Biff_unions/SHAPEPROPS.h \
    ../XlsFormat/Logic/Biff_unions/SHAREDSTRINGS.h \
    ../XlsFormat/Logic/Biff_unions/SHFMLA_SET.h \
    ../XlsFormat/Logic/Biff_unions/SORT.h \
    ../XlsFormat/Logic/Biff_unions/SORTANDFILTER.h \
    ../XlsFormat/Logic/Biff_unions/SORTDATA12.h \
    ../XlsFormat/Logic/Biff_unions/SS.h \
    ../XlsFormat/Logic/Biff_unions/STYLES.h \
    ../XlsFormat/Logic/Biff_unions/SUB.h \
    ../XlsFormat/Logic/Biff_unions/SUPBOOK.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLAUTOSORT.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLCACHE.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLCACHE12.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLCACHEFIELD.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLCACHEITEM.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLCALCMEMBER.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLCONDFMT.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLCONDFMTS.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLDBQUERY.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLFIELD.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLFIELD12.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLGROUP.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLGRPLEVEL.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLHIERARCHY.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLQSI.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLSXDH.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLSXFILT.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLSXFILTER12.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLSXFILTERS12.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLSXMG.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLSXMGS.h \
    ../XlsFormat/Logic/Biff_unions/SXADDLSXRULE.h \
    ../XlsFormat/Logic/Biff_unions/SXSRC.h \
    ../XlsFormat/Logic/Biff_unions/SXTBL.h \
    ../XlsFormat/Logic/Biff_unions/TABLESTYLES.h \
    ../XlsFormat/Logic/Biff_unions/TEXTOBJECT.h \
    ../XlsFormat/Logic/Biff_unions/TEXTPROPS.h \
    ../XlsFormat/Logic/Biff_unions/THEME.h \
    ../XlsFormat/Logic/Biff_unions/UNKNOWNFRT.h \
    ../XlsFormat/Logic/Biff_unions/WINDOW.h \
    ../XlsFormat/Logic/Biff_unions/XFS.h \
    ../XlsFormat/Logic/SummaryInformationStream/Structures/Property.h \
    ../XlsFormat/Logic/SummaryInformationStream/Structures/PropertyFactory.h \
    ../XlsFormat/Logic/SummaryInformationStream/Structures/PropertySet.h \
    ../XlsFormat/Logic/SummaryInformationStream/Structures/PropertySetStream.h \
    ../XlsFormat/Logic/SummaryInformationStream/SummaryInformation.h \
    ../Common/common.h \
    ../Common/simple_xml_writer.h \
    ../Common/utils.h \
    ../XlsXlsxConverter/ConvertXls2Xlsx.h \
    ../XlsXlsxConverter/external_items.h \
    ../XlsXlsxConverter/mediaitems_utils.h \
    ../XlsXlsxConverter/namespaces.h \
    ../XlsXlsxConverter/oox_content_type.h \
    ../XlsXlsxConverter/oox_package.h \
    ../XlsXlsxConverter/oox_rels.h \
    ../XlsXlsxConverter/progressCallback.h \
    ../XlsXlsxConverter/XlsConverter.h \
    ../XlsXlsxConverter/xlsx_conversion_context.h \
    ../XlsXlsxConverter/xlsx_drawing_context.h \
    ../XlsXlsxConverter/xlsx_drawings.h \
    ../XlsXlsxConverter/xlsx_hyperlinks.h \
    ../XlsXlsxConverter/xlsx_output_xml.h \
    ../XlsXlsxConverter/xlsx_package.h \
    ../XlsXlsxConverter/xlsx_protection.h \
    ../XlsXlsxConverter/xlsx_tablecontext.h \
    ../XlsXlsxConverter/xlsx_textcontext.h \
    ../XlsFormat/Logic/AnyObject.h \
    ../XlsFormat/Logic/AnySubstream.h \
    ../XlsFormat/Logic/BaseObject.h \
    ../XlsFormat/Logic/BaseObjectDocument.h \
    ../XlsFormat/Logic/BinProcessor.h \
    ../XlsFormat/Logic/BinProcessor.h.autosave \
    ../XlsFormat/Logic/ChartSheetSubstream.h \
    ../XlsFormat/Logic/CompositeObject.h \
    ../XlsFormat/Logic/GlobalsSubstream.h \
    ../XlsFormat/Logic/GlobalWorkbookInfo.h \
    ../XlsFormat/Logic/MacroSheetSubstream.h \
    ../XlsFormat/Logic/WorkbookStreamObject.h \
    ../XlsFormat/Logic/WorksheetSubstream.h \
    ../XlsFormat/Logic/XlsElementsType.h \
    ../XlsXlsxConverter/ShapeType.h \
    ../XlsFormat/Auxiliary/HelpFunc.h \
    ../XlsFormat/Logic/SummaryInformationStream/Structures/CodePageOle.h \
    ../XlsFormat/Logic/Biff_structures/SharedProperty.h \
    ../XlsXlsxConverter/xlsx_chart_context.h \
    ../XlsFormat/Logic/Biff_records/FrtWrapper.h \
    ../XlsXlsxConverter/ConvertShapes/BaseShape.h \
    ../XlsXlsxConverter/ConvertShapes/BinaryReader.h \
    ../XlsXlsxConverter/ConvertShapes/CustomGeomShape.h \
    ../XlsXlsxConverter/ConvertShapes/CustomShapeConvert.h \
    ../XlsXlsxConverter/ConvertShapes/FormulaShape.h \
    ../XlsXlsxConverter/ConvertShapes/GraphicsPath.h \
    ../XlsXlsxConverter/ConvertShapes/PathShape.h \
    ../XlsXlsxConverter/ConvertShapes/PPTShapeEnum.h \
    ../XlsXlsxConverter/ConvertShapes/PresetShapesHeader.h \
    ../XlsXlsxConverter/ConvertShapes/ShapeUtils.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/accentbordercallout1type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/accentbordercallout3type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/accentbordercallout90type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/AccentBorderCallout2Type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/AccentCallout1Type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/AccentCallout2Type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/AccentCallout3Type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/AccentCallout90Type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/ActionButtonBack.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/ActionButtonBeginning.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/ActionButtonBlank.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/ActionButtonDocument.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/ActionButtonEnd.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/ActionButtonHelp.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/ActionButtonHome.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/ActionButtonInfo.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/ActionButtonMovie.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/ActionButtonNext.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/ActionButtonReturn.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/ActionButtonSound.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/arctype.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/BentArrowType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/BentConnector.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/BentUpArrowType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/BevelType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/BlockArcType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/BorderCallout1Type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/BorderCallout2Type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/BorderCallout3Type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/BorderCallout90Type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/BracePairType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/BracketPairType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/Callout1Type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/Callout2Type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/Callout3Type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/Callout90Type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/CanType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/ChevronType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/CircularArrowType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/CloudCalloutType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/CubeType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/CurvedConnector.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/CurvedDownArrowType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/CurvedLeftArrowType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/CurvedRightArrowType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/CurvedUpArrowType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/DiamondType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/DonutType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/DownArrowCalloutType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/DownArrowType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/EllipseRibbon2Type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/EllipseRibbonType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/EllipseType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartAlternateProcessType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartCollateType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartConnectorType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartDecisionType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartDelayType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartDisplayType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartDocumentType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartExtractType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartInputOutputType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartInternalStorageType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartMagneticDiskType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartMagneticDrumType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartMagneticTapeType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartManualInputType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartManualOperationType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartMergeType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartMultidocumentType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartOffpageConnectorType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartOnlineStorageType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartOrType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartPredefinedProcessType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartPreparationType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartProcessType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartPunchedCardType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartPunchedTapeType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartSortType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartSummingJunctionType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FlowChartTerminatorType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/FoldedCornerType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/HeartType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/HexagonType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/HomePlateType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/HorisontalScrollType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/IrregularSealOneType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/IrregularSealTwo.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/IsoscelesTriangleType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/LeftArrowCalloutType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/LeftArrowType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/LeftBraceType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/LeftBracketType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/LeftRightArrowCalloutType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/LeftRightArrowType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/LeftRightUpArrow.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/LeftUpArrowType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/LightningBoltType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/LineType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/MoonType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/NoSmokingType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/NotchedRightArrowType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/OctagonType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/ParallelogramType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/PentagonType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/PlaqueType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/PlusType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/QuadArrowCalloutType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/QuadArrowType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/RectangleType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/RibbonDownType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/RibbonUpType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/RightArrowCalloutType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/RightArrowType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/RightBracetype.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/RightBracketType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/RightTriangleType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/RoundedRectangleType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/Seal4Type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/Seal8Type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/Seal16Type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/Seal24Type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/Seal32Type.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/SmileyFaceType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/Startype.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/StraightConnectorType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/StripedRightArrowType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/SunType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/TextboxType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/TrapezoidType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/UpArrowCalloutType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/UpArrowType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/UpDownArrowCalloutType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/UpDownArrowType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/UturnArrowType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/VerticalScrollType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/WaveDoubleType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/WaveType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/WedgeEllipseCalloutType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/WedgeRectCalloutType.h \
    ../XlsXlsxConverter/ConvertShapes/oldAutoShapes/WedgeRoundedRectCalloutType.h \
    ../XlsXlsxConverter/ConvertShapes/XmlWriter.h \
    ../XlsXlsxConverter/ConvertShapes/CustomShape.h \
    ../XlsFormat/Logic/Biff_structures/AFDOperBoolErr.h \
    ../XlsFormat/Logic/Biff_structures/AFDOperXNum.h \
    ../XlsFormat/Logic/Biff_unions/IMDATAOBJECT.h \
    ../XlsFormat/Logic/Biff_records/IMDATA.h \
    ../XlsFormat/Logic/Biff_structures/CFDatabar.h




unix {
    target.path = /usr/lib
    INSTALLS += target
}

SOURCES += \
    ../XlsFormat/Logic/Biff_unions/IMDATAOBJECT.cpp \
    ../XlsFormat/Logic/Biff_records/IMDATA.cpp \
    ../XlsFormat/Logic/Biff_structures/CFDatabar.cpp
